package xslavic4.plan_vyroby;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.RandomAccessFile;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Properties;

import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;

import org.jasypt.util.password.BasicPasswordEncryptor;

public class ButtonEditor extends DefaultCellEditor {
	  protected JButton button;

	  private String label;
	  protected static JTable table;
	  protected static Stroj stroj;

	  protected static Davka davka;
	  protected static DefaultTableModel model;

	  private boolean isPushed;

	  public ButtonEditor(JCheckBox checkBox) {
	    super(checkBox);
	    button = new JButton();
	    button.setOpaque(true);
	    button.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        fireEditingStopped();
	      }
	    });
	  }

	  public Component getTableCellEditorComponent(JTable table, Object value,
	      boolean isSelected, int row, int column) {
	    if (isSelected) {
	      button.setForeground(table.getSelectionForeground());
	      button.setBackground(table.getSelectionBackground());
	    } else {
	      button.setForeground(table.getForeground());
	      button.setBackground(table.getBackground());
	    }
	    label = (value == null) ? "" : value.toString();
	    button.setText(label);
	    isPushed = true;
	    this.table = table;
	    return button;
	  }

	  public Object getCellEditorValue() {
	    if (isPushed) {
	      // 
	      // 
	     // JOptionPane.showMessageDialog(button, label + ": Ouch!" + table.getSelectedRow() + table.getSelectedColumn() + table.getName());
	    	
	    	
	      if(table.getName().equals("zamestnanci")){
	    	  if(table.getSelectedColumn()==5){
	    		  //zmenit
	    		  Prihlaseni.casovac.restart();
	    		  Zamestnanec.zobrazZmenitZamestnance();
	    	  }
	    	  if(table.getSelectedColumn()==6){
	    		  //zrusit
	    		  Prihlaseni.casovac.restart();
	    		  String str = "Opravdu chcete smazat uivatele: " + ZamestnanciJPanel.zamestnanci[table.getSelectedRow()].getJmeno() + " " + ZamestnanciJPanel.zamestnanci[table.getSelectedRow()].getPrijmeni() + " (login: " + ZamestnanciJPanel.zamestnanci[table.getSelectedRow()].getLogin() + ")";
	    		  JButton potvrdit = new JButton("Potvrdit akci");
	    		  potvrdit.addMouseListener(new MouseAdapter() {
	    				@Override
	    				public void mousePressed(MouseEvent arg0) {
	    					Zamestnanec zam = new Zamestnanec(ZamestnanciJPanel.zamestnanci[ButtonEditor.table.getSelectedRow()]);
	    					try{
	    						//data
	    						RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
	    					    FileDescriptor fdData = fileData.getFD();
	    					    FileInputStream inData = new FileInputStream(fdData);
	    					    BufferedInputStream bisData = new BufferedInputStream(inData);
	    						ObjectInputStream oisData = new ObjectInputStream(bisData);
	    					    FileOutputStream outData = new FileOutputStream(fdData);
	    					    BufferedOutputStream bosData = new BufferedOutputStream(outData);
	    						ObjectOutputStream oosData = new ObjectOutputStream(bosData);
	    						//data nacteni aktualnich
	    						try{
	    							Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
	    							Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
	    							Vyroba.material = (ArrayList<Material>) oisData.readObject();
	    						}catch(Exception ex){
	    							ex.printStackTrace();
	    						}
	    						fileData.seek(0);
	    						//uzivatele 
	    						boolean nalezeno = false;
	    						for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
	    							if(Vyroba.zamestnanci.get(i).equals(zam)){
	    								//provedeni vsech zmen
	    								Vyroba.zrusitPrideleniZamestnance(Vyroba.zamestnanci.get(i));
	    								Vyroba.zamestnanci.get(i).zrusitPrihlasovaciUdaje();
	    								Vyroba.remZamestnanci(i);
	    								//data ulozeni
	    								try{
	    									oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
	    									oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
	    									oosData.writeObject(new ArrayList<Material>(Vyroba.material));
	    								}catch(Exception ex){
	    									ex.printStackTrace();
	    									throw new Exception("Nepodarily se ulozit nove data");
	    								}
	    								Prihlaseni.zu.setVisible(false);
	    								//restart zalozky
	    								Prihlaseni.zobrazZamestnance();
	    								nalezeno = true;
	    								break;
	    							}
	    						}
	    						if(!nalezeno){
	    							Prihlaseni.zobrazChybu("Dan zamstnanec byl v meziase zmnn/zruen jinm uivatelem!");
	    							throw new Exception("Dan zamstnanec byl v meziase zmnn jinm uivatelem");
	    						}
	    						oosData.close();
	    						bosData.close();
	    						outData.close();
	    						oisData.close();
	    						bisData.close();
	    						inData.close();
	    						fileData.close();
	    					}catch(Exception ex){
	    						System.err.println("chyba u aktualizace dat");
	    						ex.printStackTrace();
	    					}
	    				}
	    			});
	    		  JButton zrusit = new JButton("Zruit akci");
	    		  zrusit.addMouseListener(new MouseAdapter() {
	    				@Override
	    				public void mousePressed(MouseEvent arg0) {
	    					Prihlaseni.zu.setVisible(false);
	    				}
	    			});
	    		  Prihlaseni.zobrazUpozorneni(str, potvrdit, zrusit);
	    	  }
	      }
	      if(table.getName().equals("oznameni")){
	    	  Prihlaseni.casovac.restart();
	    	  try{
					//data
					RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
				    FileDescriptor fdData = fileData.getFD();
				    FileInputStream inData = new FileInputStream(fdData);
				    BufferedInputStream bisData = new BufferedInputStream(inData);
					ObjectInputStream oisData = new ObjectInputStream(bisData);
				    FileOutputStream outData = new FileOutputStream(fdData);
				    BufferedOutputStream bosData = new BufferedOutputStream(outData);
					ObjectOutputStream oosData = new ObjectOutputStream(bosData);
					//data nacteni aktualnich
					try{
						Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
						Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
						Vyroba.material = (ArrayList<Material>) oisData.readObject();
					}catch(Exception ex){
						ex.printStackTrace();
					}
					fileData.seek(0);
					//uzivatele 
					boolean nalezeno = false;
					boolean nalezenoOznameni = false;
					for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
						if(Vyroba.zamestnanci.get(i).getLogin().equals(Prihlaseni.loginUzivatele)){
							for(int x = 0; x < Vyroba.zamestnanci.get(i).getSystemovaOznameni().size(); x++){
								if(Vyroba.zamestnanci.get(i).getSystemovaOznameni().get(x).getHlaska().equals(OznameniJPanel.data[table.getSelectedRow()][1])){
									//provedeni vsech zmen
									Vyroba.zamestnanci.get(i).getSystemovaOznameni().remove(x);
									//data ulozeni
									try{
										oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
										oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
										oosData.writeObject(new ArrayList<Material>(Vyroba.material));
									}catch(Exception ex){
										ex.printStackTrace();
										throw new Exception("Nepodarily se ulozit nove data");
									}
    								//restart zalozky
									Prihlaseni.casovac.restart();
									HlavniOkno.vymazPodokna();
									HlavniOkno.oznameni = new OznameniJPanel();
									HlavniOkno.oznameni.setBounds(0, 0, 950, 479);
									HlavniOkno.layeredPane.add(HlavniOkno.oznameni);
									nalezenoOznameni = true;
									break;
								}
							}
							nalezeno = true;
							break;
						}
					}
					if(!nalezeno){
						Prihlaseni.zobrazChybu("V et byl v meziase zmnn/zruen jinm uivatelem!");
						throw new Exception("V et byl v meziase zmnn jinm uivatelem");
					}
					if(!nalezenoOznameni){
						Prihlaseni.zobrazChybu("Dan oznmen bylo v meziase zrueno");
						throw new Exception("Dan oznmen bylo v meziase zrueno");
					}
					oosData.close();
					bosData.close();
					outData.close();
					oisData.close();
					bisData.close();
					inData.close();
					fileData.close();
				}catch(Exception ex){
					System.err.println("chyba u aktualizace dat");
					ex.printStackTrace();
				}
	      }
	      
	      if(table.getName().equals("stroje")){
	    	  Prihlaseni.casovac.restart();
	    	  if(table.getSelectedColumn()==5){
	    		  //Dvky
	    		  if(Prihlaseni.role.equals("mistr")){
	    			  DavkyOkno.stroj = StrojeMistriJPanel.stroje[table.getSelectedRow()];
	    		  }else{
	    			  DavkyOkno.stroj = StrojeJPanel.stroje[table.getSelectedRow()];
	    		  }
	    		  Stroj.zobrazDavky();
	    	  }
	    	  if(table.getSelectedColumn()==6){
	    		  //zmena Dlnci - pro mistry a zaroven administratory
	    		  
	    			  if(Prihlaseni.role.equals("mistr")){
	    				  if(StrojeMistriJPanel.stroje[table.getSelectedRow()].getAktivni()){
	    					  PrirazeniZamestnancuOkno.stroj = StrojeMistriJPanel.stroje[table.getSelectedRow()];
	    					  Stroj.zobrazPrirazeniZamestnancu();
	    				  }else{
	    					  Prihlaseni.zobrazChybu("Stroj nen zaazen do vroby. ");
	    				  }
		    		  }else{
		    			  if(StrojeJPanel.stroje[table.getSelectedRow()].getAktivni()){
		    				  PrirazeniZamestnancuOkno.stroj = StrojeJPanel.stroje[table.getSelectedRow()];
		    				  Stroj.zobrazPrirazeniZamestnancu();
		    			  }else{
	    					  Prihlaseni.zobrazChybu("Stroj nen zaazen do vroby. ");
	    				  }
		    		  }
	    	  }
	    	  if(table.getSelectedColumn()==7){
	    		  //zmena Misti - pro administratory
	    		  PrirazeniMistruOkno.stroj = StrojeJPanel.stroje[table.getSelectedRow()];
	    		  Stroj.zobrazPrirazeniMistru();
	    	  }
	    	  if(table.getSelectedColumn()==8){
	    		  //Zmnit
	    		  for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
						if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(StrojeJPanel.stroje[table.getSelectedRow()].getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje() == StrojeJPanel.stroje[table.getSelectedRow()].getCisloStroje()){
								stroj = Vyroba.vyrobniStroje.get(i);
							break;
						}
	    		  }
	    		  Prihlaseni.zso = new ZmenitStrojOkno();
	    		  ZmenitStrojOkno.textField.setText(ButtonEditor.stroj.getSAPOznaceni());
	    		  ZmenitStrojOkno.textField_1.setText(Integer.toString(ButtonEditor.stroj.getCisloStroje()));
	    		  ZmenitStrojOkno.textField_2.setText(ButtonEditor.stroj.getVyrobce());
	    		  ZmenitStrojOkno.textField_3.setText(ButtonEditor.stroj.getNazevProduktu());
	    		  ZmenitStrojOkno.textField_4.setText(ButtonEditor.stroj.getUmisteni());
	    		  ZmenitStrojOkno.txtpnSdf.setText(ButtonEditor.stroj.getPopis());
	    		  if(ButtonEditor.stroj.getAktivni()){
	    			  ZmenitStrojOkno.choice.select("ano");
	    		  }else{
	    			  ZmenitStrojOkno.choice.select("ne");
	    		  }
	    		  boolean smeny[] = ButtonEditor.stroj.getSmeny();
	    		  if(smeny[0]){
	    			  ZmenitStrojOkno.chckbxNewCheckBox.setSelected(true);
	    		  }else{
	    			  ZmenitStrojOkno.chckbxNewCheckBox.setSelected(false);
	    		  }
	    		  if(smeny[1]){
	    			  ZmenitStrojOkno.chckbxOdpoledn.setSelected(true);
	    		  }else{
	    			  ZmenitStrojOkno.chckbxOdpoledn.setSelected(false);
	    		  }
	    		  if(smeny[2]){
	    			  ZmenitStrojOkno.chckbxNon.setSelected(true);
	    		  }else{
	    			  ZmenitStrojOkno.chckbxNon.setSelected(false);
	    		  }
	    		  Prihlaseni.zso.setVisible(true);
	    	  }
	    	  if(table.getSelectedColumn()==9){
	    		  //Vyadit
	    		  String str = "";
	    		  if(Prihlaseni.getRole().equals("administrator")){
	    			  str = "Opravdu chcete smazat tento stroj: SAP oznaen " + StrojeJPanel.data[table.getSelectedRow()][0] + ", slo stroje " + StrojeJPanel.data[table.getSelectedRow()][1] + ", vrobce a nzev " + StrojeJPanel.data[table.getSelectedRow()][2] + ": " + StrojeJPanel.data[table.getSelectedRow()][3];
	    		  }else{
	    			  str = "Opravdu chcete smazat tento stroj: SAP oznaen " + StrojeMistriJPanel.data[table.getSelectedRow()][0] + ", slo stroje " + StrojeMistriJPanel.data[table.getSelectedRow()][1] + ", vrobce a nzev " + StrojeMistriJPanel.data[table.getSelectedRow()][2] + ": " + StrojeMistriJPanel.data[table.getSelectedRow()][3];
	    		  }
	    		  
	    		  JButton potvrdit = new JButton("Potvrdit akci");
	    		  potvrdit.addMouseListener(new MouseAdapter() {
	    				@Override
	    				public void mousePressed(MouseEvent arg0) {
	    					try{
	    						//data
	    						RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
	    					    FileDescriptor fdData = fileData.getFD();
	    					    FileInputStream inData = new FileInputStream(fdData);
	    					    BufferedInputStream bisData = new BufferedInputStream(inData);
	    						ObjectInputStream oisData = new ObjectInputStream(bisData);
	    					    FileOutputStream outData = new FileOutputStream(fdData);
	    					    BufferedOutputStream bosData = new BufferedOutputStream(outData);
	    						ObjectOutputStream oosData = new ObjectOutputStream(bosData);
	    						//data nacteni aktualnich
	    						try{
	    							Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
	    							Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
	    							Vyroba.material = (ArrayList<Material>) oisData.readObject();
	    						}catch(Exception ex){
	    							ex.printStackTrace();
	    						}
	    						fileData.seek(0);
	    						//uzivatele 
	    						boolean nalezeno = false;
    							if(Prihlaseni.getRole().equals("administrator")){
    								for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
    									if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(StrojeJPanel.stroje[table.getSelectedRow()].getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje() == StrojeJPanel.stroje[table.getSelectedRow()].getCisloStroje()){
    	    								//oznameni
    	    								Oznameni oz1 = new Oznameni("Stroj se SAP oznaenm " + Vyroba.vyrobniStroje.get(i).getSAPOznaceni() + ", firemnm slem " + Vyroba.vyrobniStroje.get(i).getCisloStroje() + " (nzev: " + Vyroba.vyrobniStroje.get(i).getVyrobce() + ": " + Vyroba.vyrobniStroje.get(i).getNazevProduktu() + ")" + " byl vyazen z provozu.");
    	    								Oznameni oz2 = new Oznameni("Stroj se SAP oznaenm " + Vyroba.vyrobniStroje.get(i).getSAPOznaceni() + ", firemnm slem " + Vyroba.vyrobniStroje.get(i).getCisloStroje() + " (nzev: " + Vyroba.vyrobniStroje.get(i).getVyrobce() + ": " + Vyroba.vyrobniStroje.get(i).getNazevProduktu() + ")" + ", jeho jste mistrem,  byl vyazen z provozu.");
    										Vyroba.oznameni.add(oz1);
    										Vyroba.oznameni.add(oz2);
    										for(int x = 0; x < Vyroba.zamestnanci.size()-1; x++){
    											if(Vyroba.zamestnanci.get(x).getRole().equals("administrator")){
    												Vyroba.zamestnanci.get(x).addOznameni(oz1);
    											}else{
    												if(Vyroba.vyrobniStroje.get(i).getMistri().contains(Vyroba.zamestnanci.get(x))){
    													Vyroba.zamestnanci.get(x).addOznameni(oz1);
    												}
    											}
    										}
    										//provedeni vsech zmen
    	    								Vyroba.vyraditStroj(Vyroba.vyrobniStroje.get(i));
    	    								//data ulozeni
    	    								try{
    	    									oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
    	    									oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
    	    									oosData.writeObject(new ArrayList<Material>(Vyroba.material));
    	    								}catch(Exception ex){
    	    									ex.printStackTrace();
    	    									throw new Exception("Nepodarily se ulozit nove data");
    	    								}
    	    								//restart zalozky
    	    								Prihlaseni.zu.setVisible(false);
    	    								Prihlaseni.zobrazStroje();
    	    								nalezeno = true;
    	    								break;
    	    							}
    								}
    							}else{
    								for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
    									if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(StrojeMistriJPanel.stroje[table.getSelectedRow()].getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje() == StrojeMistriJPanel.stroje[table.getSelectedRow()].getCisloStroje()){
    										//oznameni
    	    								Oznameni oz1 = new Oznameni("Stroj se SAP oznaenm " + Vyroba.vyrobniStroje.get(i).getSAPOznaceni() + ", firemnm slem " + Vyroba.vyrobniStroje.get(i).getCisloStroje() + " (nzev: " + Vyroba.vyrobniStroje.get(i).getVyrobce() + ": " + Vyroba.vyrobniStroje.get(i).getNazevProduktu() + ")" + " byl vyazen z provozu.");
    	    								Oznameni oz2 = new Oznameni("Stroj se SAP oznaenm " + Vyroba.vyrobniStroje.get(i).getSAPOznaceni() + ", firemnm slem " + Vyroba.vyrobniStroje.get(i).getCisloStroje() + " (nzev: " + Vyroba.vyrobniStroje.get(i).getVyrobce() + ": " + Vyroba.vyrobniStroje.get(i).getNazevProduktu() + ")" + ", jeho jste mistrem,  byl vyazen z provozu.");
    										Vyroba.oznameni.add(oz1);
    										Vyroba.oznameni.add(oz2);
    										for(int x = 0; x < Vyroba.zamestnanci.size()-1; x++){
    											if(Vyroba.zamestnanci.get(x).getRole().equals("administrator")){
    												Vyroba.zamestnanci.get(x).addOznameni(oz1);
    											}else{
    												if(Vyroba.vyrobniStroje.get(i).getMistri().contains(Vyroba.zamestnanci.get(x))){
    													Vyroba.zamestnanci.get(x).addOznameni(oz1);
    												}
    											}
    										}
    										//provedeni vsech zmen
    	    								Vyroba.vyraditStroj(Vyroba.vyrobniStroje.get(i));
    	    								//data ulozeni
    	    								try{
    	    									oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
    	    									oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
    	    									oosData.writeObject(new ArrayList<Material>(Vyroba.material));
    	    								}catch(Exception ex){
    	    									ex.printStackTrace();
    	    									nalezeno = true;
    	    									throw new Exception("Nepodarily se ulozit nove data");
    	    								}
    	    								//restart zalozky
    	    								Prihlaseni.zu.setVisible(false);
    	    								Prihlaseni.zobrazStroje();
    	    								nalezeno = true;
    	    								break;
    	    							}
    								}
    							}
	    						if(!nalezeno){
	    							Prihlaseni.zobrazChybu("Dan stroj byl v meziase zruen jinm uivatelem!");
	    							throw new Exception("Dan stroj byl v meziase zruen jinm uivatelem!");
	    						}
	    						oosData.close();
	    						bosData.close();
	    						outData.close();
	    						oisData.close();
	    						bisData.close();
	    						inData.close();
	    						fileData.close();
	    					}catch(Exception ex){
	    						System.err.println("chyba u aktualizace dat");
	    						ex.printStackTrace();
	    					}
	    				}
	    			});
	    		  JButton zrusit = new JButton("Zruit akci");
	    		  zrusit.addMouseListener(new MouseAdapter() {
	    				@Override
	    				public void mousePressed(MouseEvent arg0) {
	    					Prihlaseni.zu.setVisible(false);
	    				}
	    			});
	    		  Prihlaseni.zobrazUpozorneni(str, potvrdit, zrusit);
	    	  }
	    	  
	      }
	      if(table.getName().equals("davky")){
	    	  Prihlaseni.casovac.restart();
	    	  if(table.getSelectedColumn()==6){
	    		  //"Rozdlit", 
	    		  RozdeleniDavkyOkno.table = ButtonEditor.table;
	    		  Stroj.zobrazRozdeleniDavky();
	    	  }
	    	  if(table.getSelectedColumn()==7){
	    		  //"Pln", 
	    		if(!DavkyOkno.davky[table.getSelectedRow()].getSerizeni()){
	    		stroj = DavkyOkno.stroj;
	  	    	for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
	  	    		if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==stroj.getCisloStroje()){
	  	    			stroj = Vyroba.vyrobniStroje.get(i);
	  	    			break;
	  	    		}
	  	    	}
	  	    		Davka.zobrazPlanSmen();
					//nastaveni tlacitka vytvorit
					PlanSmenOkno.okButton.setText("Zmnit");
					PlanSmenOkno.okButton.addMouseListener(new MouseAdapter() {
						@Override
						public void mousePressed(MouseEvent arg0) {
							if(Davka.souhlasiMnozstviSPlanem(davka.getDataSmen().size(), davka.getCelkoveMnozstvi())){
								try{
									//data
									RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
								    FileDescriptor fdData = fileData.getFD();
								    FileInputStream inData = new FileInputStream(fdData);
								    BufferedInputStream bisData = new BufferedInputStream(inData);
									ObjectInputStream oisData = new ObjectInputStream(bisData);
								    FileOutputStream outData = new FileOutputStream(fdData);
								    BufferedOutputStream bosData = new BufferedOutputStream(outData);
									ObjectOutputStream oosData = new ObjectOutputStream(bosData);
									//data nacteni aktualnich
									try{
										Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
										Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
										Vyroba.material = (ArrayList<Material>) oisData.readObject();
									}catch(Exception ex){
										ex.printStackTrace();
									}
									fileData.seek(0);
									boolean nalezeno = false;
									boolean nalezeno2 = false;
									for(int x = 0; x < Vyroba.vyrobniStroje.size(); x++){
										if(Vyroba.vyrobniStroje.get(x).getSAPOznaceni().equals(stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(x).getCisloStroje()==stroj.getCisloStroje()){
											for(int i = 0; i < Vyroba.vyrobniStroje.get(x).getDavka().size(); i++){
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(i).equals(davka)){
													for(int z = 0; z < Vyroba.vyrobniStroje.get(x).getDavka().get(i).getDataSmen().size(); z++){
														Vyroba.vyrobniStroje.get(x).getDavka().get(i).planSmen.set(z, Integer.parseInt((String)model.getValueAt(0, z)));
													}
													Oznameni oz = new Oznameni("Dvka s oznaenm " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceni() + " (oznaen sti: " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceniCasti() + ") byla zmnna.");
													Vyroba.oznameni.add(oz);
													for(int q = 0; q < Vyroba.zamestnanci.size(); q++){
														if(Vyroba.vyrobniStroje.get(x).getMistri().contains(Vyroba.zamestnanci.get(q))){
															Vyroba.zamestnanci.get(q).addOznameni(oz);
														}
													}
													//data ulozeni
													try{
														oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
														oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
														oosData.writeObject(new ArrayList<Material>(Vyroba.material));
													}catch(Exception ex){
														ex.printStackTrace();
													}
													Prihlaseni.ps.setVisible(false);
													Prihlaseni.dav.setVisible(false);
													//restart zalozky
													Stroj.zobrazDavky();
													Prihlaseni.zobrazPotvrzeni("Pln dvky s hlavnm oznaenm " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceni() + " (oznaen sti: " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceniCasti() + ")" + " byl spn zmnn.");
													nalezeno2 = true;
													break;
												}
											}
											nalezeno = true;
										}
									}
									if(!nalezeno){
										Prihlaseni.zobrazChybu("Stroj u kterho se snate zmnit pln dvky byl v meziase zmnn. ");
										throw new Exception("Stroj u kterho se snate zmnit pln dvky byl v meziase zmnn. ");
									}
									if(nalezeno&&!nalezeno2){
										Prihlaseni.zobrazChybu("Dvka u kter se pokoute zmnit plnovanou vrobu byla v meziase zmnna jinm uivatelem. ");
										throw new Exception("Dvka u kter se pokoute zmnit plnovanou vrobu byla v meziase zmnna jinm uivatelem. ");
									}
									oosData.close();
									bosData.close();
									outData.close();
									oisData.close();
									bisData.close();
									inData.close();
									fileData.close();
								}catch(Exception ex){
									System.err.println("chyba u aktualizace dat");
									ex.printStackTrace();
								}
							}else{
								Prihlaseni.zobrazChybu("Celkov vyrbn mnostv nesouhlas se sumou stek, kter jste uvedli v tabulce!");
							}
						}
					});
					
					//naplneni tabulky
					boolean nalezeno = false;
					Object data[][];
					for(int i = 0; i < stroj.getDavka().size(); i++){
						if(DavkyOkno.davky[table.getSelectedRow()].equals(stroj.getDavka().get(i))){
							davka = stroj.getDavka().get(i);
							SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm, EEE");  
							String[] columnNames = new String[stroj.getDavka().get(i).dataSmen.size()];
							data = new Object[1][stroj.getDavka().get(i).dataSmen.size()];
							for(int x = 0; x < stroj.getDavka().get(i).dataSmen.size(); x++){
								data[0][x] = Integer.toString(stroj.getDavka().get(i).planSmen.get(x));
								columnNames[x] = format.format(stroj.getDavka().get(i).dataSmen.get(x).getTime());
							}
							model = new DefaultTableModel(data, columnNames) {
							    @Override
							    public boolean isCellEditable(int row, int column) {
							    	return true;
							    }
							};
							PlanSmenOkno.table = new JTable(model);
							PlanSmenOkno.table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
							for(int x = 0; x < stroj.getDavka().get(i).dataSmen.size(); x++){
								PlanSmenOkno.table.getColumnModel().getColumn(x).setMinWidth(130);
							}
							PlanSmenOkno.table.setName("Pln smn");
							PlanSmenOkno.scrollPane.setViewportView(PlanSmenOkno.table);
							PlanSmenOkno.scrollPane.setVerticalScrollBar(new JScrollBar());
							nalezeno = true;
							break;
						}
					}
					if(!nalezeno){
						Prihlaseni.zobrazChybu("Dvka danho stroje byla v meziase zmnna.");
					}
	    		}else{
	    			Prihlaseni.zobrazChybu("U seizovacho typu dvky je bezpedmtn mnit pln vroby. Je nulov pro vechny smny. ");
	    		}
	    		  //-
	    	  }
	    	  if(table.getSelectedColumn()==8){
	    		  //"Zmnit", 
	    		  Davka.zobrazUdajeDavky();
	    		  
	    	  }
	    	  if(table.getSelectedColumn()==9){
	    		  //"Zruit"
	    		  try{
						//data
						RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
					    FileDescriptor fdData = fileData.getFD();
					    FileInputStream inData = new FileInputStream(fdData);
					    BufferedInputStream bisData = new BufferedInputStream(inData);
						ObjectInputStream oisData = new ObjectInputStream(bisData);
					    FileOutputStream outData = new FileOutputStream(fdData);
					    BufferedOutputStream bosData = new BufferedOutputStream(outData);
						ObjectOutputStream oosData = new ObjectOutputStream(bosData);
						//data nacteni aktualnich
						try{
							Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
							Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
							Vyroba.material = (ArrayList<Material>) oisData.readObject();
						}catch(Exception ex){
							ex.printStackTrace();
						}
						fileData.seek(0);
						boolean nalezeno = false;
						for(int x = 0; x < Vyroba.vyrobniStroje.size(); x++){
							if(Vyroba.vyrobniStroje.get(x).getSAPOznaceni().equals(DavkyOkno.stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(x).getCisloStroje()==DavkyOkno.stroj.getCisloStroje()){
								for(int i = 0; i < Vyroba.vyrobniStroje.get(x).getDavka().size(); i++){
									if(Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceni().equals(DavkyOkno.davky[table.getSelectedRow()].getOznaceni())&&Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceniCasti().equals(DavkyOkno.davky[table.getSelectedRow()].getOznaceniCasti())){
										//provedeni vsech zmen
										SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm, EEE"); 
										Calendar c1 = Vyroba.vyrobniStroje.get(x).getDavka().get(i).getPlanovanyZacatek();
										Calendar c2 = Vyroba.vyrobniStroje.get(x).getDavka().get(i).getPlanovanyKonec();
										Oznameni oz;
										//zajimavejsi by to bylo kdyby se nuly nehybaly = zustaly by v kalednari na svem miste (klidne i v jine davce)
										List<Calendar> data = new ArrayList<Calendar>();
										for(int z = i; z < Vyroba.vyrobniStroje.get(x).getDavka().size(); z++){
											for(int y = 0; y < Vyroba.vyrobniStroje.get(x).getDavka().get(z).getDataSmen().size(); y++){
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(z).getDataSmen().get(y).getTimeInMillis()>Prihlaseni.dnesniDatum.getTimeInMillis()){
													data.add(Vyroba.vyrobniStroje.get(x).getDavka().get(z).getDataSmen().get(y));
												}
											}
										}
										for(int z = i+1; z < Vyroba.vyrobniStroje.get(x).getDavka().size(); z++){
											for(int y = 0; y < Vyroba.vyrobniStroje.get(x).getDavka().get(z).getDataSmen().size(); y++){
												if(y==0){
													Vyroba.vyrobniStroje.get(x).getDavka().get(z).setPlanovanyZacatek(data.get(0));
												}
												if(y==Vyroba.vyrobniStroje.get(x).getDavka().get(z).getDataSmen().size()-1){
													Vyroba.vyrobniStroje.get(x).getDavka().get(z).setPlanovanyKonec(data.get(0));
												}
												Vyroba.vyrobniStroje.get(x).getDavka().get(z).getDataSmen().set(y, data.get(0));
												data.remove(0);
											}
										}
										if(Vyroba.vyrobniStroje.get(x).getDavka().get(i).getPlanovanyZacatek().getTimeInMillis()<Prihlaseni.dnesniDatum.getTimeInMillis()){
											for(int y = 0; y < Vyroba.vyrobniStroje.get(x).getDavka().get(i).getDataSmen().size(); y++){
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(i).getDataSmen().get(y).getTimeInMillis()>Prihlaseni.dnesniDatum.getTimeInMillis()){
													Vyroba.vyrobniStroje.get(x).getDavka().get(i).getDataSmen().remove(y);
													y--;
												}else{
													Vyroba.vyrobniStroje.get(x).getDavka().get(i).setPlanovanyKonec(Vyroba.vyrobniStroje.get(x).getDavka().get(i).getDataSmen().get(y));
												}
											}
											oz = new Oznameni("Dvka s oznaenm " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceni() + " (oznaen sti: " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceniCasti() + ") od: " + format.format(c1.getTime()) + "do: " + format.format(c2.getTime()) + ", byla sten odstranna.");
										}else{
											oz = new Oznameni("Dvka s oznaenm " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceni() + " (oznaen sti: " + Vyroba.vyrobniStroje.get(x).getDavka().get(i).getOznaceniCasti() + ") od: " + format.format(c1.getTime()) + "do: " + format.format(c2.getTime()) + ", byla odstranna.");
											Vyroba.vyrobniStroje.get(x).remDavka(i);
										}
										//oznameni
										Vyroba.oznameni.add(oz);
										for(int q = 0; q < Vyroba.zamestnanci.size(); q++){
											if(Vyroba.vyrobniStroje.get(x).getMistri().contains(Vyroba.zamestnanci.get(q))){
												Vyroba.zamestnanci.get(x).addOznameni(oz);
											}
										}
										
										//data ulozeni
										try{
											oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
											oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
											oosData.writeObject(new ArrayList<Material>(Vyroba.material));
										}catch(Exception ex){
											ex.printStackTrace();
											throw new Exception("Nepodarily se ulozit nove data");
										}
										Prihlaseni.dav.setVisible(false);
										Stroj.zobrazDavky();
										nalezeno = true;
										break;
									}
								}
								break;
							}
						}
							
						if(!nalezeno){
							Prihlaseni.zobrazChybu("Dan dvka byla v meziase zmnna jinm uivatelem");
							throw new Exception("Dan dvka byla v meziase zmnna jinm uivatelem");
						}
						oosData.close();
						bosData.close();
						outData.close();
						oisData.close();
						bisData.close();
						inData.close();
						fileData.close();
					}catch(Exception ex){
						System.err.println("chyba u aktualizace dat");
						ex.printStackTrace();
					}
	    	  }
	      }
	      if(table.getName().equals("volno")){
	    	  Prihlaseni.casovac.restart();
	    	  	try{
					//data
					RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
				    FileDescriptor fdData = fileData.getFD();
				    FileInputStream inData = new FileInputStream(fdData);
				    BufferedInputStream bisData = new BufferedInputStream(inData);
					ObjectInputStream oisData = new ObjectInputStream(bisData);
				    FileOutputStream outData = new FileOutputStream(fdData);
				    BufferedOutputStream bosData = new BufferedOutputStream(outData);
					ObjectOutputStream oosData = new ObjectOutputStream(bosData);
					//data nacteni aktualnich
					try{
						Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
						Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
						Vyroba.material = (ArrayList<Material>) oisData.readObject();
					}catch(Exception ex){
						ex.printStackTrace();
					}
					fileData.seek(0);
					boolean nalezeno = false;
					for(int x = 0; x < Vyroba.vyrobniStroje.size(); x++){
						if(Vyroba.vyrobniStroje.get(x).getSAPOznaceni().equals(DavkyOkno.stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(x).getCisloStroje()==DavkyOkno.stroj.getCisloStroje()){
							for(int i = 0; i < Vyroba.vyrobniStroje.get(x).getVolno().size(); i++){
								if(Vyroba.vyrobniStroje.get(x).getVolno().get(i).equals(VolnoOkno.volno[VolnoOkno.table.getSelectedRow()])){
									//provedeni vsech zmen
									Calendar cal = (Calendar) Vyroba.vyrobniStroje.get(x).getVolno(i).clone();
									Vyroba.vyrobniStroje.get(x).getVolno().remove(i);
									int poziceDavky = -1;
									int indexDavky = 0;
									for(int q = 0; q < Vyroba.vyrobniStroje.get(x).getDavka().size(); q++){
										for(int y = 0; y < Vyroba.vyrobniStroje.get(x).getDavka().get(q).getDataSmen().size(); y++){
											if(Vyroba.vyrobniStroje.get(x).getDavka().get(q).getDataSmen().get(y).getTimeInMillis()>=cal.getTimeInMillis()){
												poziceDavky = q;
												indexDavky = y;
												break;
											}
										}
										if(poziceDavky!=-1){
											break;
										}
									}
									//zmenime data u smeny, ktere se to dotklo
									if(cal.get(Calendar.HOUR_OF_DAY)==6){
										for(int q = indexDavky; q < Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen();){
											if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[0]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
												Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
												if(q==0){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
												}
												q++;
												if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
													break;
												}
											}
											cal = (Calendar) cal.clone();
											cal.add(Calendar.HOUR_OF_DAY, 8);
											if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[1]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
												Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
												if(q==0){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
												}
												q++;
												if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
													break;
												}
											}
											cal = (Calendar) cal.clone();
											cal.add(Calendar.HOUR_OF_DAY, 8);
											if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[2]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
												Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
												if(q==0){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
												}
												q++;
												if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
													break;
												}
											}
											cal = (Calendar) cal.clone();
											cal.add(Calendar.HOUR_OF_DAY, 8);
										}
									}else{
										if(cal.get(Calendar.HOUR_OF_DAY)==14){
											for(int q = indexDavky; q < Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen();){
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[1]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[2]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[0]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
											}
										}else{
											for(int q = indexDavky; q < Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen();){
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[2]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[0]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).smeny[1]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
											}
										}
									}
									//zmenime vsechny davky po zmenene
									for(int y = poziceDavky+1; y < Vyroba.vyrobniStroje.get(x).getDavka().size(); y++){
										cal = (Calendar) cal.clone();
										cal.add(Calendar.HOUR_OF_DAY, 8);
										if(cal.get(Calendar.HOUR_OF_DAY)==6){
											for(int q = 0; q < Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen();){
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[0]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[1]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[2]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
													Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
													if(q==0){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
													}
													q++;
													if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
														break;
													}
												}
												cal = (Calendar) cal.clone();
												cal.add(Calendar.HOUR_OF_DAY, 8);
											}
										}else{
											if(cal.get(Calendar.HOUR_OF_DAY)==14){
												for(int q = 0; q < Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen();){
													if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[1]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
														if(q==0){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
														}
														q++;
														if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
															break;
														}
													}
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
													if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[2]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
														if(q==0){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
														}
														q++;
														if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
															break;
														}
													}
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
													if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[0]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
														if(q==0){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
														}
														q++;
														if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
															break;
														}
													}
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
												}
											}else{
												for(int q = 0; q < Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen();){
													if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[2]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
														if(q==0){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
														}
														q++;
														if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
															break;
														}
													}
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
													if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[0]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
														if(q==0){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
														}
														q++;
														if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
															break;
														}
													}
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
													if(Vyroba.vyrobniStroje.get(x).getDavka().get(y).smeny[1]&&!Vyroba.vyrobniStroje.get(x).getVolno().contains(cal)){
														Vyroba.vyrobniStroje.get(x).getDavka().get(y).dataSmen.set(q, cal);
														if(q==0){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyZacatek(cal);
														}
														q++;
														if(q == Vyroba.vyrobniStroje.get(x).getDavka().get(y).getPocetSmen()){
															Vyroba.vyrobniStroje.get(x).getDavka().get(y).setPlanovanyKonec(cal);
															break;
														}
													}
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
												}
											}
										}
									}
									//data ulozeni
									try{
										oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
										oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
										oosData.writeObject(new ArrayList<Material>(Vyroba.material));
									}catch(Exception ex){
										ex.printStackTrace();
										throw new Exception("Nepodarily se ulozit nove data");
									}
									nalezeno = true;
									break;
								}
							}
							break;
						}
					}
						
					if(!nalezeno){
						Prihlaseni.zobrazChybu("Dan datum ji bylo odstraeno jinm uivatelem");
						throw new Exception("Dan datum ji bylo odstraeno jinm uivatelem");
					}
					oosData.close();
					bosData.close();
					outData.close();
					oisData.close();
					bisData.close();
					inData.close();
					fileData.close();
				}catch(Exception ex){
					System.err.println("chyba u aktualizace dat");
					ex.printStackTrace();
				}
	    	  	Prihlaseni.dav.setVisible(false);
	    	  	Stroj.zobrazDavky();
	    	  	Prihlaseni.dav.setVisible(true);
	    	  	Prihlaseni.vo.setVisible(false);
				Prihlaseni.vo = new VolnoOkno();
				Prihlaseni.vo.setVisible(true);
	      	}
	      
	      	if(table.getName().equals("vyroba")){
	      		Prihlaseni.casovac.restart();
	      		//zjistime zmenu o kolik + ulozime si stroj, davku, datumsmeny
	      		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm");
	      		int puvodni; int nova;
	      		if(VyrobaJPanel.data[table.getSelectedRow()][7] instanceof Integer){
	      			puvodni = (int) VyrobaJPanel.data[table.getSelectedRow()][7];
	      		}else{
	      			puvodni = Integer.parseInt((String) VyrobaJPanel.data[table.getSelectedRow()][7]);
	      		}
	      		if(VyrobaJPanel.model.getValueAt(table.getSelectedRow(), 7) instanceof Integer){
	      			nova = (int) VyrobaJPanel.model.getValueAt(table.getSelectedRow(), 7);
	      		}else{
	      			nova = Integer.parseInt((String) VyrobaJPanel.model.getValueAt(table.getSelectedRow(), 7));
	      		}
	      		int oKolik = - puvodni + nova;
	      		String oznStroje = (String) VyrobaJPanel.data[table.getSelectedRow()][0];
	      		int cisloStroje = (int) VyrobaJPanel.data[table.getSelectedRow()][1];
	      		String oznDavky = (String) VyrobaJPanel.data[table.getSelectedRow()][2];
	      		String oznCasti = (String) VyrobaJPanel.data[table.getSelectedRow()][3];
	      		Calendar smena = (Calendar) VyrobaJPanel.smeny[table.getSelectedRow()].clone();
	      		if(oKolik!=0){
	      		//nacteme soubor a k polozce pridame hodnotu o kolik ji uzivatel zmenil u sebe + kontrola (vyroba celkem nemuze byt vetsi jak plan)
	      		try{
					//data
					RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
				    FileDescriptor fdData = fileData.getFD();
				    FileInputStream inData = new FileInputStream(fdData);
				    BufferedInputStream bisData = new BufferedInputStream(inData);
					ObjectInputStream oisData = new ObjectInputStream(bisData);
				    FileOutputStream outData = new FileOutputStream(fdData);
				    BufferedOutputStream bosData = new BufferedOutputStream(outData);
					ObjectOutputStream oosData = new ObjectOutputStream(bosData);
					//data nacteni aktualnich
					try{
						Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
						Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
						Vyroba.material = (ArrayList<Material>) oisData.readObject();
					}catch(Exception ex){
						ex.printStackTrace();
					}
					fileData.seek(0);
					boolean nepresahloMnozstvi = false;
					boolean nalezenStroj = false;
					boolean nalezenaDavka = false;
					boolean nalezenaSmena = true;
					int zbyva = 0;
					for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
						if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(oznStroje)&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==cisloStroje){
							for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().size(); x++){
								if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni().equals(oznDavky)&&Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceniCasti().equals(oznCasti)){
									for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.size(); q++){
										if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.get(q).equals(smena)){
											zbyva = Vyroba.vyrobniStroje.get(i).getDavka().get(x).zbyvaVyrobit();
											if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).zbyvaVyrobit()>=oKolik){
												//zapis vyroby
												Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.set(q, Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.get(q)+oKolik);
												//kontrola dokoncenosti a pripadne zkraceni davek - staci jen ty, ktere se menili
												boolean preskladano = false;
												if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).zbyvaVyrobit()==0){
													while(Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.get(Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.size()-1)==0&&Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.get(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.size()-1).getTimeInMillis()>Prihlaseni.dnesniDatum.getTimeInMillis()){
														preskladano = true;
														Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.remove(Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.size()-1);
														Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.remove(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.size()-1);
														//!mozna bude nutne mazat i plan - ale po smazani by se prislo o moznou statistiku plneni procent
													}
												}
												if(preskladano){
													//nutno zmenit planovanyKonec
													Vyroba.vyrobniStroje.get(i).getDavka().get(x).setPlanovanyKonec(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.get(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.size()-1));
													//preskladani davek po teto davce
													Calendar cal = (Calendar) Vyroba.vyrobniStroje.get(i).getDavka().get(x).getPlanovanyKonec().clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
													for(int a = x+1; a < Vyroba.vyrobniStroje.get(i).getDavka().size(); a++){
														if(cal.get(Calendar.HOUR_OF_DAY)==6){
															for(int b = 0; b < Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen();){
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																	if(b==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																	}
																	b++;
																	if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																		cal = (Calendar) cal.clone();
																		cal.add(Calendar.HOUR_OF_DAY, 8);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																	if(b==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																	}
																	b++;
																	if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																		cal = (Calendar) cal.clone();
																		cal.add(Calendar.HOUR_OF_DAY, 8);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																	if(b==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																	}
																	b++;
																	if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																		cal = (Calendar) cal.clone();
																		cal.add(Calendar.HOUR_OF_DAY, 8);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
															}
														}else{
															if(cal.get(Calendar.HOUR_OF_DAY)==14){
																for(int b = 0; b < Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen();){
																	if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																		if(b==0){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																		}
																		b++;
																		if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																			cal = (Calendar) cal.clone();
																			cal.add(Calendar.HOUR_OF_DAY, 8);
																			break;
																		}
																	}
																	cal = (Calendar) cal.clone();
																	cal.add(Calendar.HOUR_OF_DAY, 8);
																	if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																		if(b==0){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																		}
																		b++;
																		if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																			cal = (Calendar) cal.clone();
																			cal.add(Calendar.HOUR_OF_DAY, 8);
																			break;
																		}
																	}
																	cal = (Calendar) cal.clone();
																	cal.add(Calendar.HOUR_OF_DAY, 8);
																	if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																		if(b==0){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																		}
																		b++;
																		if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																			cal = (Calendar) cal.clone();
																			cal.add(Calendar.HOUR_OF_DAY, 8);
																			break;
																		}
																	}
																	cal = (Calendar) cal.clone();
																	cal.add(Calendar.HOUR_OF_DAY, 8);
																}
															}else{
																for(int b = 0; b < Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen();){
																	if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																		if(b==0){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																		}
																		b++;
																		if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																			cal = (Calendar) cal.clone();
																			cal.add(Calendar.HOUR_OF_DAY, 8);
																			break;
																		}
																	}
																	cal = (Calendar) cal.clone();
																	cal.add(Calendar.HOUR_OF_DAY, 8);
																	if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																		if(b==0){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																		}
																		b++;
																		if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																			cal = (Calendar) cal.clone();
																			cal.add(Calendar.HOUR_OF_DAY, 8);
																			break;
																		}
																	}
																	cal = (Calendar) cal.clone();
																	cal.add(Calendar.HOUR_OF_DAY, 8);
																	if(Vyroba.vyrobniStroje.get(i).getDavka().get(a).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(a).dataSmen.set(b, cal);
																		if(b==0){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyZacatek(cal);
																		}
																		b++;
																		if(b == Vyroba.vyrobniStroje.get(i).getDavka().get(a).getPocetSmen()){
																			Vyroba.vyrobniStroje.get(i).getDavka().get(a).setPlanovanyKonec(cal);
																			cal = (Calendar) cal.clone();
																			cal.add(Calendar.HOUR_OF_DAY, 8);
																			break;
																		}
																	}
																	cal = (Calendar) cal.clone();
																	cal.add(Calendar.HOUR_OF_DAY, 8);
																}
															}
														}
													}
													
													
													
												}
												//oznameni
												Oznameni oz1 = new Oznameni("Byla zapsna vroba u stroje " + Vyroba.vyrobniStroje.get(i).getSAPOznaceni() + " (" + Vyroba.vyrobniStroje.get(i).getCisloStroje() + "), u dvky " + Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni() + "(slo sti: " + Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceniCasti() + "), smna " + format.format(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.get(q).getTime()) + ", v mnostv: " + oKolik);
												Vyroba.oznameni.add(oz1);
												for(int y = 0; y < Vyroba.zamestnanci.size(); y++){
													if(Vyroba.vyrobniStroje.get(i).getMistri().contains(Vyroba.zamestnanci.get(y))){
														Vyroba.zamestnanci.get(y).addOznameni(oz1);
													}else{
														if(Vyroba.vyrobniStroje.get(i).getDelnici().contains(Vyroba.zamestnanci.get(y))){
															Vyroba.zamestnanci.get(y).addOznameni(oz1);
														}
													}
												}
												//data ulozeni
												try{
													oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
													oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
													oosData.writeObject(new ArrayList<Material>(Vyroba.material));
												}catch(Exception ex){
													ex.printStackTrace();
													throw new Exception("Nepodarily se ulozit nove data");
												}
												nepresahloMnozstvi = true;
												break;
											}
											nalezenaSmena = true;
											break;
										}
									}
									nalezenaDavka = true;
									break;
								}
							}
							nalezenStroj = true;
							break;
						}
					}
					if(!nalezenStroj){
						Prihlaseni.zobrazChybu("Dan stroj byl v meziase zmnn.");
					}
					if(nalezenStroj&&!nalezenaDavka){
						Prihlaseni.zobrazChybu("Dan dvka byla v meziase zmnna.");
					}
					if(nalezenStroj&&nalezenaDavka&&!nalezenaSmena){
						Prihlaseni.zobrazChybu("Smna, ke kter mla bt vroba zadna, byla v meziase zmnna.");
					}
					if(nalezenStroj&&nalezenaDavka&&nalezenaSmena&&!nepresahloMnozstvi){
						Prihlaseni.zobrazChybu("Toto mnostv nelze zadat, peshlo by pln dvky. Zadejte maximln " + zbyva + " kus.");
					}
					oosData.close();
					bosData.close();
					outData.close();
					oisData.close();
					bisData.close();
					inData.close();
					fileData.close();
					if(nepresahloMnozstvi){
						//restart zalozky
						Prihlaseni.zobrazZapisVyroby();
						Prihlaseni.zobrazPotvrzeni("Hodnota spn zapsna");
					}
				}catch(Exception ex){
					System.err.println("chyba u aktualizace dat");
					ex.printStackTrace();
				}
	      	}
	      	}
	      	
	      	if(table.getName().equals("koeficient")){
	      		Prihlaseni.casovac.restart();
	      		Calendar calZ;
				Calendar calK;
				try{
					calZ = Calendar.getInstance();
					calZ.setTime(KoeficientJPanel.model.getValue());
				}catch(NullPointerException ex){
					calZ = (Calendar) Prihlaseni.dnesniDatum.clone();
				}
				calZ.set(Calendar.MILLISECOND, 0);
				calZ.set(Calendar.SECOND, 0);
				calZ.set(Calendar.MINUTE, 0);
				calZ.set(Calendar.HOUR_OF_DAY, 0);
				calZ.set(Calendar.DAY_OF_WEEK, 0);
				calZ.add(Calendar.DATE, -5);
				calK = (Calendar) calZ.clone();
				calK.add(Calendar.DATE, 7);
				String sapOznaceni = KoeficientJPanel.stroje[KoeficientJPanel.table.getSelectedRow()].getSAPOznaceni();
				int cislo = KoeficientJPanel.stroje[KoeficientJPanel.table.getSelectedRow()].getCisloStroje();
				
	      		boolean nalezeno = false;
	      		List<String> oznaceniDavky = new ArrayList<String>();
	      		List<String> oznaceniCasti = new ArrayList<String>();
	      		List<String> vyrobek = new ArrayList<String>();
	      		List<String> materialDilec = new ArrayList<String>();
	      		List<Integer> zkraceni = new ArrayList<Integer>();
	      		List<Float> hrubyPrumer = new ArrayList<Float>();
	      		List<Float> cistyPrumer = new ArrayList<Float>();
	      		List<Integer> moznychSmen = new ArrayList<Integer>();
	      		List<Integer> odpracovanychSmen = new ArrayList<Integer>();
	      		int sumaVyroby = 0;
	      		int sumaDilcu = 0;
	      		for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
	      			if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(sapOznaceni)&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==cislo){
	      				for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().size(); x++){
	      					if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getPlanovanyKonec().getTimeInMillis()>calZ.getTimeInMillis()&&Vyroba.vyrobniStroje.get(i).getDavka().get(x).getPlanovanyZacatek().getTimeInMillis()<calK.getTimeInMillis()&&!Vyroba.vyrobniStroje.get(i).getDavka().get(x).getSerizeni()){
	      						oznaceniDavky.add(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni());
	      						oznaceniCasti.add(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceniCasti());
	      						vyrobek.add(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getVyrobek());
	      						materialDilec.add(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getMaterial().getOznaceni() + ":" + Vyroba.vyrobniStroje.get(i).getDavka().get(x).getMaterial().getPocet());
	      						zkraceni.add(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen.size() - Vyroba.vyrobniStroje.get(i).getDavka().get(x).getPocetSmen());
	      						int sumaCisty = 0;
	      						int pocCisty = 0;
	      						int sumaHruby = 0;
	      						int pocHruby = 0;
	      						int moznychKOdpracovani = 0;
	      						int odpracovanych = 0;
	      						sumaDilcu += Vyroba.vyrobniStroje.get(i).getDavka().get(x).getMaterial().getPocet();
	      						for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().size(); q++){
	      							if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().get(q).getTimeInMillis()>calZ.getTimeInMillis()&&Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().get(q).getTimeInMillis()<calK.getTimeInMillis()){
	      								if(q!=0&&q!=Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().size()-1){
	      									pocCisty++;
	      									sumaCisty += Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.get(q);
	      								}
	      								pocHruby++;
	      								sumaHruby += Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.get(q);
	      								if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.get(q)!=0){
	      									odpracovanych++;
	      									sumaVyroby += Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen.get(q);
	      								}
	      								moznychKOdpracovani++;
	      							}
	      						}
	      						cistyPrumer.add((float) sumaCisty/pocCisty);
	      						hrubyPrumer.add((float) sumaHruby/pocHruby);
	      						moznychSmen.add(moznychKOdpracovani);
	      						odpracovanychSmen.add(odpracovanych);
	      					}
	      				}
	      				nalezeno = true;
	      				break;
	      			}
	      		}
	      		if(!nalezeno){
	      			Prihlaseni.zobrazChybu("Stroj byl v meziase zmnn jinm uivatelem.");
	      		}else{
	      			if(oznaceniDavky.size()==0){
	      				SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
	      				Prihlaseni.ko = new KoeficientOkno();
	      				Prihlaseni.ko.setVisible(true);
	      				Prihlaseni.ko.setTitle("Koeficient vroby stroje od " + format.format(calZ.getTime()) + " do " + format.format(calK.getTime()));
	      				Prihlaseni.ko.textField.setText("0");
	      			}else{
	      				SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
	      				Prihlaseni.ko = new KoeficientOkno();
	      				Prihlaseni.ko.setVisible(true);
	      				Prihlaseni.ko.setTitle("Koeficient vroby stroje od " + format.format(calZ.getTime()) + " do " + format.format(calK.getTime()));
	      				//koeficient
	      				float koef = (float) sumaVyroby / sumaDilcu;
	      				Prihlaseni.ko.textField.setText(new DecimalFormat("#.##").format(koef));
	      				//tabulka
	      				String[] columnNames = {"Oznaen", "Oznaen sti", "Vrobek", "Materil", "Prodlen", "Hrub prmr", "ist prmr", "Monch smn", "Vyuitch smn"};
	      				Object data[][] = new Object[oznaceniDavky.size()][9];
	      				for(int i = 0; i < oznaceniDavky.size(); i++){
	      					data[i][0] = oznaceniDavky.get(i);
	      					data[i][1] = oznaceniCasti.get(i);
	      					data[i][2] = vyrobek.get(i);
	      					data[i][3] = materialDilec.get(i);
	      					data[i][4] = zkraceni.get(i);
	      					data[i][5] = hrubyPrumer.get(i);
	      					data[i][6] = cistyPrumer.get(i);
	      					data[i][7] = moznychSmen.get(i);
	      					data[i][8] = odpracovanychSmen.get(i);
	      				}
	      					
	      				DefaultTableModel model = new DefaultTableModel(data, columnNames) {
	      				    @Override
	      				    public boolean isCellEditable(int row, int column) {
	      				    	return false;
	      				    }
	      				};
	      				
	      				Prihlaseni.ko.table = new JTable(model);
	      				Prihlaseni.ko.table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	      				Prihlaseni.ko.table.setName("koef");
	      				Prihlaseni.ko.scrollPane.setViewportView(Prihlaseni.ko.table);
	      			}
	      		}
	      	}
	      	
	      
	    }
	    isPushed = false;
	    return new String(label);
	  }

	  public boolean stopCellEditing() {
	    isPushed = false;
	    return super.stopCellEditing();
	  }

	  protected void fireEditingStopped() {
	    super.fireEditingStopped();
	  }
	}

