package xslavic4.plan_vyroby;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

public class Davka implements Serializable{

	private static final long serialVersionUID = 4294752367956345584L;
	
	private String vyrobek;
	private int celkoveMnozstvi = 0;
	private String oznaceni;
	private int pocetSmen;
	private List<String> kratkeDavky = new ArrayList<String>();
	private Material material;
	private Calendar puvodniZacatek;
	private Calendar puvodniKonec;
	private boolean serizeni;
	protected List<Integer> planSmen = new ArrayList<Integer>();
	protected List<Calendar> dataSmen = new ArrayList<Calendar>();
	protected List<Integer> skutecnostSmen = new ArrayList<Integer>();
	private Calendar planovanyZacatek;
	private Calendar planovanyKonec;
	private Calendar skutecnyZacatek;
	private Calendar skutecnyKonec;
	private String oznaceniCasti = "";
	protected boolean[] smeny = new boolean[3];

	public Davka() {
	}
	
	public Davka(Davka dav) {
		vyrobek = dav.vyrobek;
		celkoveMnozstvi = dav.celkoveMnozstvi;
		oznaceni = dav.oznaceni;
		pocetSmen = dav.pocetSmen;
		kratkeDavky = dav.kratkeDavky;
		puvodniZacatek = dav.puvodniZacatek;
		puvodniKonec = dav.puvodniKonec;
		material = dav.material;
		serizeni = dav.serizeni;
		planSmen = dav.planSmen;
		dataSmen = dav.dataSmen;
		skutecnostSmen = dav.skutecnostSmen;
		planovanyZacatek = dav.planovanyZacatek;
		planovanyKonec = dav.planovanyKonec;
		skutecnyZacatek = dav.skutecnyZacatek;
		skutecnyKonec = dav.skutecnyKonec;
		//oznaceniCasti = dav.oznaceniCasti;
	}

	public String getVyrobek() {
		return this.vyrobek;
	}

	public void setVyrobek(String vyrobek) {
		this.vyrobek = vyrobek;
	}

	public int getCelkoveMnozstvi() {
		return this.celkoveMnozstvi;
	}

	public void setCelkoveMnozstvi(int celkoveMnozstvi) {
		if(celkoveMnozstvi<0){
			try {
				Prihlaseni.zobrazChybu("Neme bt vyrbn zporn poet vrobk!");
				throw new Exception("Nemuze byt vyraben zaporny pocet vyrobku!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			this.celkoveMnozstvi = celkoveMnozstvi;
		}
	}

	public String getOznaceni() {
		return this.oznaceni;
	}

	public void setOznaceni(String oznaceni) {
		boolean jedinecneOznaceni = true;
		for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
			for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().size(); x++){
				if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni().equals(oznaceni)){
					jedinecneOznaceni = false;
					break;
				}
			}
			if(!jedinecneOznaceni){
				break;
			}
		}
		if(!jedinecneOznaceni){
			try {
				Prihlaseni.zobrazChybu("Oznaen dvky nen jedinen!");
				throw new Exception("Oznaceni davky neni jedinecne!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			this.oznaceni = oznaceni;
		}
	}

	public int getPocetSmen() {
		return this.pocetSmen;
	}

	public void setPocetSmen(int pocetSmen) {
		if(pocetSmen<1){
			try {
				Prihlaseni.zobrazChybu("Nelze vyrbt krat dobu jak 1 smna!");
				throw new Exception("Nelze vyrabet kratsi dobu jak 1 smena!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			this.pocetSmen = pocetSmen;
		}
	}

	public List<String> getKratkeDavky() {
		return kratkeDavky;
	}
	
	public void setKratkeDavky(List<String> kd) {
		kratkeDavky = kd;
	}

	public void addKratkeDavky(String kratkeDavky) {
		this.kratkeDavky.add(kratkeDavky);
	}

	public void remKratkeDavky(int idx) {
		kratkeDavky.remove(idx);
	}

	public Material getMaterial() {
		return this.material;
	}

	public void setMaterial(Material material) {
		this.material = material;
	}

	public Calendar getPuvodniZacatek() {
		return this.puvodniZacatek;
	}

	public void setPuvodniZacatek(Calendar puvodniZacatek) {
		this.puvodniZacatek = puvodniZacatek;
	}

	public Calendar getPuvodniKonec() {
		return this.puvodniKonec;
	}

	public void setPuvodniKonec(Calendar puvodniKonec) {
		this.puvodniKonec = puvodniKonec;
	}

	public boolean getSerizeni() {
		return this.serizeni;
	}

	public void setSerizeni2(boolean serizeni) {
		this.serizeni = serizeni;
		if(serizeni==true){
			celkoveMnozstvi = 0;
			planSmen = new ArrayList<Integer>();
			dataSmen = new ArrayList<Calendar>();
			skutecnostSmen = new ArrayList<Integer>();
		}else{
			if(celkoveMnozstvi==0){
				try {
					Prihlaseni.zobrazChybu("Ped zmnou dvky ze seizovac na vrobn, zadejte poet vyrbnch kus!");
					throw new Exception("Pred zmenou davky ze serizovaci na vyrobni, zadejte pocet vyrabenych kusu!");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	public void setSerizeni(boolean serizeni) {
		this.serizeni = serizeni;
	}

	public List<Integer> getPlanSmen() {
		return planSmen;
	}

	public void setPlanSmen(List<Integer> planSmen) {
		this.planSmen = planSmen;
	}

	public List<Integer> getSkutecnostSmen() {
		return skutecnostSmen;
	}

	public Calendar getPlanovanyZacatek() {
		return this.planovanyZacatek;
	}

	public void setPlanovanyZacatek(Calendar planovanyZacatek) {
		this.planovanyZacatek = planovanyZacatek;
	}

	public Calendar getSkutecnyKonec() {
		return this.skutecnyKonec;
	}

	public void setSkutecnyKonec(Calendar skutecnyKonec) {
		this.skutecnyKonec = skutecnyKonec;
	}

	public void rovnomernyPlanSmen2(boolean[] smeny) {
		double cm = new Double(celkoveMnozstvi);
		for(int i = 0; i < pocetSmen; i++){
			planSmen.set(i,(int)Math.round(cm/(pocetSmen-i)));
			cm = cm - Math.round(cm/(pocetSmen-i));
		}
		pracovniSmeny(smeny);
	}
	
	public static int[] rovnomernyPlanSmen(boolean[] smeny, int celkMnoz, int pocSmen) {
		int mnozstvi[] = new int[pocSmen];
		double cm = new Double(celkMnoz);
		for(int i = 0; i < pocSmen; i++){
			mnozstvi[i] = (int)Math.round(cm/(pocSmen-i));
			cm = cm - Math.round(cm/(pocSmen-i));
		}
		return mnozstvi;
	}
	
	private void pracovniSmeny(boolean[] smeny){
		Calendar da = planovanyZacatek;
		for(int i = 0; i < pocetSmen; i++){
			if(da.get(Calendar.HOUR_OF_DAY)==6&&smeny[0]==true){
				Calendar novy = (Calendar) da.clone();
				dataSmen.add(novy);
			}else{
				if(da.get(Calendar.HOUR_OF_DAY)==14&&smeny[1]==true){
					Calendar novy = (Calendar) da.clone();
					dataSmen.add(novy);
				}else{
					if(da.get(Calendar.HOUR_OF_DAY)==22&&smeny[2]==true){
						Calendar novy = (Calendar) da.clone();
						dataSmen.add(novy);
					}
				}
			}
			da.add(Calendar.HOUR_OF_DAY, 8);
		}
	}

	public Calendar getPlanovanyKonec() {
		return this.planovanyKonec;
	}

	public void setPlanovanyKonec(Calendar planovanyKonec) {
		this.planovanyKonec = planovanyKonec;
	}

	public List<Calendar> getDataSmen() {
		return this.dataSmen;
	}

	public void setDataSmen(List<Calendar> dataSmen) {
		this.dataSmen = dataSmen;
	}

	public Calendar getSkutecnyZacatek() {
		return this.skutecnyZacatek;
	}

	public void setSkutecnyZacatek(Calendar skutecnyZacatek) {
		this.skutecnyZacatek = skutecnyZacatek;
	}

	public String getOznaceniCasti() {
		return this.oznaceniCasti;
	}

	public void setOznaceniCasti(String oznaceniCasti) {
		this.oznaceniCasti = oznaceniCasti;
	}

	public int vyrobeno(){
		int cv = 0;
		for(int i = 0; i < dataSmen.size(); i++){
			cv += skutecnostSmen.get(i);
		}
		return cv;
	}
	
	public int zbyvaVyrobit() {
		int cv = 0;
		for(int i = 0; i < dataSmen.size(); i++){
			cv += skutecnostSmen.get(i);
		}
		return celkoveMnozstvi - cv;
	}

	public static void zobrazPlanSmen() {
		Prihlaseni.casovac.restart();
		Prihlaseni.ps = new PlanSmenOkno();
		Prihlaseni.ps.setVisible(true);
	}

	public void zmenUdaje(String vyr, int cm, String oz, int ps, List<String> kd, Material mat, boolean ser, List<Integer> psmen, List<Calendar>ds, List<Integer> ss, Calendar planz, Calendar plank, Calendar skutz, Calendar skutk, String oc) {
		if(celkoveMnozstvi<0){
			try {
				Prihlaseni.zobrazChybu("Neme bt vyrbn zporn poet vrobk!");
				throw new Exception("Nemuze byt vyraben zaporny pocet vyrobku!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			boolean jedinecneOznaceni = true;
			for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
				for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().size(); x++){
					if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni().equals(oz)){
						jedinecneOznaceni = false;
						break;
					}
				}
				if(!jedinecneOznaceni){
					break;
				}
			}
			if(!jedinecneOznaceni){
				try {
					Prihlaseni.zobrazChybu("Oznaen dvky nen jedinen!");
					throw new Exception("Oznaceni davky neni jedinecne!");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}else{
				if(pocetSmen<1){
					try {
						Prihlaseni.zobrazChybu("Nelze vyrbt krat dobu jak 1 smna!");
						throw new Exception("Nelze vyrbt krat dobu jak 1 smna!");
					} catch (Exception e) {
						e.printStackTrace();
					}
				}else{
					if(serizeni==true){
						celkoveMnozstvi = 0;
						planSmen = new ArrayList<Integer>();
						dataSmen = new ArrayList<Calendar>();
						skutecnostSmen = new ArrayList<Integer>();
						vyrobek = null;
					}else{
						if(celkoveMnozstvi==0){
							try {
								Prihlaseni.zobrazChybu("Ped zmnou dvky ze seizovac na vrobn, zadejte poet vyrbnch kus!");
								throw new Exception("Pred zmenou davky ze serizovaci na vyrobni, zadejte pocet vyrabenych kusu!");
							} catch (Exception e) {
								e.printStackTrace();
							}
						}
						celkoveMnozstvi = cm;
						planSmen = psmen;
						dataSmen = ds;
						skutecnostSmen = ss;
						vyrobek = vyr;
					}
					oznaceni = oz;
					pocetSmen = ps;
					kratkeDavky = kd;
					material = mat;
					serizeni = ser;
					planovanyZacatek = planz;
					planovanyKonec = plank;
					skutecnyZacatek = skutz;
					skutecnyKonec = skutk;
					oznaceniCasti = oc;
				}
			}
		}
	}

	public static void zobrazUdajeDavky() {
		Prihlaseni.casovac.restart();
		Prihlaseni.zd = new ZmenitDavkaOkno(DavkyOkno.davky[ButtonEditor.table.getSelectedRow()]);
		Prihlaseni.zd.setVisible(true);
	}

	public boolean souhlasiMnozstviSPlanemSmen3() {
		int cm = 0;
		for(int i = 0; i < pocetSmen; i++){
			cm += planSmen.get(i);
		}
		if(cm==celkoveMnozstvi){
			return true;
		}else{
			return false;
		}
	}
	
	public static boolean souhlasiMnozstviSPlanem(){
		int celkem = 0;
		for(int i = 0; i < Integer.parseInt(NovaDavkaOkno.textField_2.getText()); i++){
			celkem = celkem + Integer.parseInt((String)NovaDavkaOkno.model.getValueAt(0, i));
		}
		if(celkem==Integer.parseInt(NovaDavkaOkno.textField_3.getText())){
			return true;
		}else{
			return false;
		}
	}
	
	public static boolean souhlasiMnozstviSPlanem(int pocetPoli, int vyrabeneMnozstvi){
		int celkem = 0;
		for(int i = 0; i < pocetPoli; i++){
			celkem = celkem + Integer.parseInt((String)ButtonEditor.model.getValueAt(0, i));
		}
		if(celkem==vyrabeneMnozstvi){
			return true;
		}else{
			return false;
		}
	}
	
	public static boolean souhlasiMnozstviSPlanemZmenit(int pocetPoli, int vyrabeneMnozstvi){
		int celkem = 0;
		for(int i = 0; i < pocetPoli; i++){
			celkem = celkem + Integer.parseInt((String)ZmenitDavkaOkno.model.getValueAt(0, i));
		}
		if(celkem==vyrabeneMnozstvi){
			return true;
		}else{
			return false;
		}
	}

	public void zapisVvrobu(int idx, int mnozstvi) {
		if(!(zbyvaVyrobit()-mnozstvi>=0)){
			try {
				Prihlaseni.zobrazChybu("Nelze vyrobit v dvce vce ne na kolik byla naplnovna!");
				throw new Exception("Nelze vyrobit v davce vice nez na kolik byla naplanovana!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			skutecnostSmen.set(idx,mnozstvi);
		}
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + celkoveMnozstvi;
		result = prime * result
				+ ((oznaceni == null) ? 0 : oznaceni.hashCode());
		result = prime * result
				+ ((oznaceniCasti == null) ? 0 : oznaceniCasti.hashCode());
		result = prime * result
				+ ((planovanyKonec == null) ? 0 : planovanyKonec.hashCode());
		result = prime
				* result
				+ ((planovanyZacatek == null) ? 0 : planovanyZacatek.hashCode());
		result = prime * result + pocetSmen;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Davka other = (Davka) obj;
		if (celkoveMnozstvi != other.celkoveMnozstvi)
			return false;
		if (oznaceni == null) {
			if (other.oznaceni != null)
				return false;
		} else if (!oznaceni.equals(other.oznaceni))
			return false;
		if (oznaceniCasti == null) {
			if (other.oznaceniCasti != null)
				return false;
		} else if (!oznaceniCasti.equals(other.oznaceniCasti))
			return false;
		if (planovanyKonec == null) {
			if (other.planovanyKonec != null)
				return false;
		} else if (!planovanyKonec.equals(other.planovanyKonec))
			return false;
		if (planovanyZacatek == null) {
			if (other.planovanyZacatek != null)
				return false;
		} else if (!planovanyZacatek.equals(other.planovanyZacatek))
			return false;
		if (pocetSmen != other.pocetSmen)
			return false;
		return true;
	}

	

	
	
}