package xslavic4.plan_vyroby;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JList;

import org.jasypt.util.password.BasicPasswordEncryptor;
import org.jdatepicker.impl.DateComponentFormatter;
import org.jdatepicker.impl.JDatePanelImpl;
import org.jdatepicker.impl.JDatePickerImpl;
import org.jdatepicker.impl.UtilDateModel;

import java.awt.Choice;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Properties;

public class NoveVolnoOkno extends JDialog {

	private final JPanel contentPanel = new JPanel();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			NoveVolnoOkno dialog = new NoveVolnoOkno();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public NoveVolnoOkno() {
		setTitle("Nov\u00E9 volno");
		setBounds(100, 100, 417, 314);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		UtilDateModel model = new UtilDateModel();
		Properties p = new Properties();
		p.put("text.today", "Dnes");
		p.put("text.month", "Msc");
		p.put("text.year", "Rok");
		JDatePanelImpl datePanel = new JDatePanelImpl(model, p);
		
		datePanel.setBounds(10, 10, 200, 200);
		contentPanel.add(datePanel);
		
		Choice choice = new Choice();
		choice.add("6:00 a 14:00");
		choice.add("14:00 a 22:00");
		choice.add("22:00 a 6:00");
		choice.setBounds(240, 10, 130, 20);
		contentPanel.add(choice);
		
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("P\u0159idat");
				okButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						Prihlaseni.casovac.restart();
						Calendar date = Calendar.getInstance();
					    date.set(Calendar.YEAR, model.getYear());
					    date.set(Calendar.MONTH, model.getMonth());
					    date.set(Calendar.DAY_OF_MONTH, model.getDay());
					    date.set(Calendar.HOUR_OF_DAY, 0);
					    date.set(Calendar.MINUTE, 0);
					    date.set(Calendar.SECOND, 0);
					    date.set(Calendar.MILLISECOND, 0);
					    if(choice.getSelectedIndex()==0){
					    	date.add(Calendar.HOUR_OF_DAY, 6);
					    }else{
					    	if(choice.getSelectedIndex()==1){
					    		date.add(Calendar.HOUR_OF_DAY, 14);
					    	}else{
					    		date.add(Calendar.HOUR_OF_DAY, 22);
					    	}
					    }
					    
					    try{
							//data
							RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
						    FileDescriptor fdData = fileData.getFD();
						    FileInputStream inData = new FileInputStream(fdData);
						    BufferedInputStream bisData = new BufferedInputStream(inData);
							ObjectInputStream oisData = new ObjectInputStream(bisData);
						    FileOutputStream outData = new FileOutputStream(fdData);
						    BufferedOutputStream bosData = new BufferedOutputStream(outData);
							ObjectOutputStream oosData = new ObjectOutputStream(bosData);
							//data nacteni aktualnich
							try{
								Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
								Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
								Vyroba.material = (ArrayList<Material>) oisData.readObject();
							}catch(Exception ex){
								ex.printStackTrace();
							}
							fileData.seek(0);
							boolean pridano = false;
							try{
								for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
									if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(DavkyOkno.stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==DavkyOkno.stroj.getCisloStroje()){
										//provedeni vsech zmen
										boolean volnoPridano = false;
										for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getVolno().size(); x++){
											//nasli jsme stejne volno
											if(Vyroba.vyrobniStroje.get(i).getVolno().get(x).getTimeInMillis()==date.getTimeInMillis()){
												Prihlaseni.zobrazChybu("Dan datum se ji u danho stroje eviduje jako den volna. ");
												pridano = true;
												break;
											}
											if(Vyroba.vyrobniStroje.get(i).getVolno().get(x).getTimeInMillis()>date.getTimeInMillis()){
												Vyroba.vyrobniStroje.get(i).getVolno().add(x, date);
												volnoPridano = true;
												break;
											}
										}
										if(!volnoPridano){
											Vyroba.vyrobniStroje.get(i).getVolno().add(date);
										}
										if(!pridano){
											Calendar cal = (Calendar) date.clone();
											//zjistime davku, jestli se to nejake nedotklo
											int poziceDavky = 0;
											int indexDavky = 0;
											boolean poskozeno = false;
											boolean poskozeno2 = false;
											for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().size(); q++){
												for(int y = 0; y < Vyroba.vyrobniStroje.get(i).getDavka().get(q).getDataSmen().size(); y++){
													if(Vyroba.vyrobniStroje.get(i).getDavka().get(q).getDataSmen().get(y).getTimeInMillis()==cal.getTimeInMillis()){
														poskozeno = true;
														poziceDavky = q;
														indexDavky = y;
														break;
													}
													if(Vyroba.vyrobniStroje.get(i).getDavka().get(q).getDataSmen().get(y).getTimeInMillis()>cal.getTimeInMillis()){
														poskozeno2 = true;
														break;
													}
												}
												if(poskozeno||poskozeno2){
													break;
												}
											}
											if(poskozeno){
												cal.add(Calendar.HOUR_OF_DAY, 8);
												if(cal.get(Calendar.HOUR_OF_DAY)==6){
													for(int q = indexDavky; q < Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen();){
														if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
															Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
															if(q==0){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
															}
															q++;
															if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																break;
															}
														}
														cal = (Calendar) cal.clone();
														cal.add(Calendar.HOUR_OF_DAY, 8);
														if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
															Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
															if(q==0){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
															}
															q++;
															if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																break;
															}
														}
														cal = (Calendar) cal.clone();
														cal.add(Calendar.HOUR_OF_DAY, 8);
														if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
															Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
															if(q==0){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
															}
															q++;
															if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																break;
															}
														}
														cal = (Calendar) cal.clone();
														cal.add(Calendar.HOUR_OF_DAY, 8);
													}
												}else{
													if(cal.get(Calendar.HOUR_OF_DAY)==14){
														for(int q = indexDavky; q < Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen();){
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
														}
													}else{
														for(int q = indexDavky; q < Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen();){
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(poziceDavky).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
														}
													}
												}
												//zmenime vsechny davky po zmenene
												for(int y = poziceDavky+1; y < Vyroba.vyrobniStroje.get(i).getDavka().size(); y++){
													cal = (Calendar) cal.clone();
													cal.add(Calendar.HOUR_OF_DAY, 8);
													if(cal.get(Calendar.HOUR_OF_DAY)==6){
														for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen();){
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
															if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																if(q==0){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																}
																q++;
																if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																	break;
																}
															}
															cal = (Calendar) cal.clone();
															cal.add(Calendar.HOUR_OF_DAY, 8);
														}
													}else{
														if(cal.get(Calendar.HOUR_OF_DAY)==14){
															for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen();){
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																	if(q==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																	}
																	q++;
																	if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																	if(q==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																	}
																	q++;
																	if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																	if(q==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																	}
																	q++;
																	if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
															}
														}else{
															for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen();){
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[2]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																	if(q==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																	}
																	q++;
																	if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[0]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																	if(q==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																	}
																	q++;
																	if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
																if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).smeny[1]&&!Vyroba.vyrobniStroje.get(i).getVolno().contains(cal)){
																	Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.set(q, cal);
																	if(q==0){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyZacatek(cal);
																	}
																	q++;
																	if(q == Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPocetSmen()){
																		Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(cal);
																		break;
																	}
																}
																cal = (Calendar) cal.clone();
																cal.add(Calendar.HOUR_OF_DAY, 8);
															}
														}
													}
												}
											}
											Prihlaseni.vo.setVisible(false);
										    Prihlaseni.vo = new VolnoOkno();
										    Prihlaseni.vo.setVisible(true);
										    Prihlaseni.nv.setVisible(true);
										    //Prihlaseni.zobrazPotvrzeni("spn pidno datum: " + date.getTime());
											pridano = true;
										}
										//data ulozeni
										oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
										oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
										oosData.writeObject(new ArrayList<Material>(Vyroba.material));
										break;
									}
								}
							}catch (Exception ex){
								ex.printStackTrace();
							}
							oosData.close();
							bosData.close();
							outData.close();
							oisData.close();
							bisData.close();
							inData.close();
							fileData.close();
						}catch(Exception ex){
							System.err.println("chyba u aktualizace dat");
							ex.printStackTrace();
						}
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Zru\u0161it");
				cancelButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						Prihlaseni.casovac.restart();
						Prihlaseni.dav.setVisible(false);
						Stroj.zobrazDavky();
						Prihlaseni.dav.setVisible(true);
						Prihlaseni.nv.setVisible(false);
						Prihlaseni.vo.setVisible(false);
						Prihlaseni.vo = new VolnoOkno();
						Prihlaseni.vo.setVisible(true);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
}
