package xslavic4.plan_vyroby;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.io.RandomAccessFile;
import java.io.Serializable;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.channels.FileChannel;
import java.nio.channels.FileLock;
import java.nio.channels.OverlappingFileLockException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Properties;

import org.jasypt.util.password.*;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.Timer;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.apache.commons.net.ntp.NTPUDPClient;
import org.apache.commons.net.ntp.TimeInfo;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class Prihlaseni implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1575672961688970793L;
	protected static String loginUzivatele;
	protected static int prihlasenyUzivatel;
	private static String jmenoUzivatele = "";
	private static String prijmeniUzivatele = "";
	//role = "administrator", "mistr", "delnik"
	protected static String role;
	protected static Calendar dnesniDatum = Calendar.getInstance();
	protected static Timer casovac;
	protected static Timer casovacData;
	protected static Timer casovacTime;
	
	private static JTextField userText;
	private static JPasswordField passwordText;
	
	protected static JFrame frmPlnVroby;
	protected static String cestaData = "data.dat";
	protected static String cestaUzivatele = "uzivatele.dat";
	
	protected static Vyroba vyr;
	protected static Nastaveni nas;
	protected static ZobrazChybu zc;
	protected static ZobrazPotvrzeni zp;
	protected static ZobrazUpozorneni zu;
	protected static HlavniOkno ho;
	
	protected static TvorbaZamestnanceOkno tz;
	protected static ZmenitZamestnanceOkno zmenz;
	protected static ZrusitZamestnanceOkno zz;
	protected static NovyStrojOkno ns;
	protected static ZmenitStrojOkno zso;
	protected static PrirazeniMistruOkno pm;
	protected static PrirazeniZamestnancuOkno pz;
	protected static DavkyOkno dav;
	protected static NovaDavkaOkno nd;
	protected static NovyMaterialOkno nm;
	protected static VolnoOkno vo;
	protected static NoveVolnoOkno nv;
	protected static PlanSmenOkno ps;
	protected static ZmenitDavkaOkno zd;
	protected static PoradiOkno pd;
	protected static RozdeleniDavkyOkno rd;
	protected static SlouceniDavkyOkno sd;
	protected static KoeficientOkno ko;

	public int getPrihlasenyUzivatel() {
		return Prihlaseni.prihlasenyUzivatel;
	}

	public void setPrihlasenyUzivatel(int prihlasenyUzivatel) {
		Prihlaseni.prihlasenyUzivatel = prihlasenyUzivatel;
	}

	public static String getRole() {
		return Prihlaseni.role;
	}

	public static void setRole(String role) {
		Prihlaseni.role = role;
	}

	public static void prihlaseni() {
		try (FileInputStream in = new FileInputStream("vp.properties")) {
			Properties properties = new Properties();
			properties.load(in);
			cestaUzivatele = properties.getProperty("Uzivatele");
			cestaData = properties.getProperty("Data");
		} catch (IOException e) {
		}

		try (FileInputStream in = new FileInputStream(cestaUzivatele)) {
			Properties properties = new Properties();
			properties.load(in);
			String inputPassword = properties.getProperty(userText.getText());
			BasicPasswordEncryptor passwordEncryptor = new BasicPasswordEncryptor();
			if (passwordEncryptor.checkPassword(String.valueOf(passwordText.getPassword()), inputPassword)) {
				System.out.println("spravne heslo");
				//nacteni vyroby ze souboru
				nactiSoubory();
				//zjisti uzivatele, roli
				for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
					if(Vyroba.zamestnanci.get(i).getLogin().equals(userText.getText())){
						loginUzivatele = Vyroba.zamestnanci.get(i).getLogin();
						prihlasenyUzivatel = Vyroba.zamestnanci.get(i).getCisloZamestnance();
						prijmeniUzivatele = Vyroba.zamestnanci.get(i).getPrijmeni();
						jmenoUzivatele = Vyroba.zamestnanci.get(i).getJmeno();
						role = Vyroba.zamestnanci.get(i).getRole();
						//Vyroba.zamestnanci.get(i).odstranStaraOznameni();
						break;
					}
				}
				zobrazHlavniOkno();
				spustCasovac();
				spustTimer();
			} else {
				System.err.println("Zadan neexistujici uzivatel nebo nespravne heslo");
				zobrazChybu("Byl zadn neexistujc uivatel nebo nesprvn heslo!");
			}
			in.close();
		} catch (IOException e) {
			System.err.println("Soubor neexistuje");
		}
	}
	
	public static void spustCasovac(){
		int delay = 1800000;
		ActionListener taskPerformer = new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					casovac.stop();
					Prihlaseni.odhlaseni();
				}
		};
		casovac = new Timer(delay, taskPerformer);
		casovac.start();
	}
	
	public static void spustData(){
		int delay = 300000;
		ActionListener taskPerformer = new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					casovacData.restart();
					nactiSoubory();
				}
		};
		casovacData = new Timer(delay, taskPerformer);
		casovacData.start();
	}
	
	public static void spustTimer(){
		int delay = 10000;
		ActionListener taskPerformer = new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					casovacTime.restart();
					dnesniDatum.add(Calendar.SECOND, 10);
					System.out.println(Prihlaseni.dnesniDatum.getTime());
				}
		};
		casovacTime = new Timer(delay, taskPerformer);
		casovacTime.start();
	}

	public static void odhlaseni() {
		casovac.stop();
		ho.setVisible(false);
		ho = null;
		userText.setText("");
		passwordText.setText("");
		frmPlnVroby.setVisible(true);
	}

	public static void nactiSoubory() {
		vyr = new Vyroba();
		try{
			FileInputStream fis = new FileInputStream(cestaData);
			BufferedInputStream bis = new BufferedInputStream(fis);
			ObjectInputStream ois = new ObjectInputStream(bis);
			Vyroba.vyrobniStroje = (ArrayList<Stroj>) ois.readObject();
			Vyroba.zamestnanci = (ArrayList<Zamestnanec>) ois.readObject();
			Vyroba.material = (ArrayList<Material>) ois.readObject();
			ois.close();
			bis.close();
			fis.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public static void aktualizujDatum() {
		//cas dela problemy - nekdy se vubec nenacte ani z PC ani ze serveru
		try {
			String TIME_SERVER = "time-b.nist.gov";   
			NTPUDPClient timeClient = new NTPUDPClient();
			InetAddress inetAddress = InetAddress.getByName(TIME_SERVER);
			TimeInfo timeInfo = timeClient.getTime(inetAddress);
			long returnTime = timeInfo.getMessage().getTransmitTimeStamp().getTime();
			Date time = new Date(returnTime);
			Prihlaseni.dnesniDatum.setTime(time);
			//System.out.println("as z internetu: " + Prihlaseni.dnesniDatum.getTime());
		} catch (UnknownHostException e) {
		} catch (IOException ex){
		} catch (NullPointerException ex){
		}
		
		//kdyz neobdrzi odpoved ze serveru, tak je nutne nacist alespon cas z PC
		
		
		/**
		String[] hosts = new String[]{"time-a.nist.gov","time-b.nist.gov","time-c.nist.gov"};
		NTPUDPClient client = new NTPUDPClient();
		client.setDefaultTimeout(1000);
		for (String host : hosts) {
			try {
				InetAddress hostAddr = InetAddress.getByName(host);
				System.out.println("> " + hostAddr.getHostName() + "/" + hostAddr.getHostAddress());
				TimeInfo info = client.getTime(hostAddr);
				Date date = new Date(info.getMessage().getTransmitTimeStamp().getTime());
				dnesniDatum.setTime(date);
			}catch (IOException e) {
				e.printStackTrace();
				dnesniDatum = Calendar.getInstance();
			}
		}
		client.close();
		*/
	}

	public static void zobrazPotvrzeni(String str) {
		Prihlaseni.casovac.restart();
		zp = new ZobrazPotvrzeni(str);
		zp.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		zp.setVisible(true);
	}

	public static void zobrazChybu(String str) {
		Prihlaseni.casovac.restart();
		zc = new ZobrazChybu(str);
		zc.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		zc.setVisible(true);
	}

	public static void zobrazUpozorneni(String str, JButton potvrdit, JButton zrusit) {
		Prihlaseni.casovac.restart();
		zu = new ZobrazUpozorneni(str,potvrdit,zrusit);
		zu.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		zu.setVisible(true);
	}

	public static void zobrazUINovyStroj() {
		Prihlaseni.casovac.restart();
		ns = new NovyStrojOkno();
		ns.setVisible(true);
	}

	public static void zobrazStroje() {
		Prihlaseni.casovac.restart();
		if(role.equals("mistr")){
			zobrazStrojeMistr();
		}
		if(role.equals("administrator")){
			zobrazStrojeAdministrator();
		}
	}
	
	private static void zobrazStrojeAdministrator(){
		HlavniOkno.vymazPodokna();
		HlavniOkno.stroje = new StrojeJPanel();
		HlavniOkno.stroje.setBounds(0, 0, 950, 479);
		HlavniOkno.layeredPane.add(HlavniOkno.stroje);
	}
	
	private static void zobrazStrojeMistr(){
		HlavniOkno.vymazPodokna();
		HlavniOkno.strojeMistri = new StrojeMistriJPanel();
		HlavniOkno.strojeMistri.setBounds(0, 0, 950, 479);
		HlavniOkno.layeredPane.add(HlavniOkno.strojeMistri);
	}

	public static void zobrazHlavniOkno() {
		ho = new HlavniOkno();
		if(role.equals("delnik")){
			HlavniOkno.toolBar.remove(HlavniOkno.btnKoeficienty);
			HlavniOkno.toolBar.remove(HlavniOkno.btnZamstnanci);
			HlavniOkno.toolBar.remove(HlavniOkno.btnStroje);
			HlavniOkno.toolBar.remove(HlavniOkno.buttonStrojeMistri);
		}
		if(role.equals("mistr")){
			HlavniOkno.toolBar.remove(HlavniOkno.btnZamstnanci);
			HlavniOkno.toolBar.remove(HlavniOkno.btnStroje);
		}
		if(role.equals("administrator")){
			HlavniOkno.toolBar.remove(HlavniOkno.buttonStrojeMistri);
		}
		ho.setTitle("Pln vroby:   " + jmenoUzivatele + " " + prijmeniUzivatele);
		ho.setVisible(true);
		frmPlnVroby.setVisible(false);
	}

	public static void zobrazPrihlasovaciOkno(JPanel panel) {
		panel.setLayout(null);
		JLabel userLabel = new JLabel("U\u017Eivatel");
		userLabel.setBounds(10, 10, 80, 25);
		panel.add(userLabel);
		userText = new JTextField(20);
		userText.setBounds(100, 10, 160, 25);
		panel.add(userText);
		JLabel passwordLabel = new JLabel("Heslo");
		passwordLabel.setBounds(10, 40, 80, 25);
		panel.add(passwordLabel);
		passwordText = new JPasswordField(20);
		passwordText.setBounds(100, 40, 160, 25);
		panel.add(passwordText);
		JButton loginButton = new JButton("p\u0159ihl\u00E1sit");
		loginButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent arg0) {
				
				prihlaseni();
				
			}
		});
		loginButton.setBounds(10, 80, 110, 25);
		panel.add(loginButton);
		JButton registerButton = new JButton("nastaven\u00ED");
		registerButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Prihlaseni.nas = new Nastaveni();
				Prihlaseni.nas
						.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
				Prihlaseni.nas.setVisible(true);
				// Prihlaseni.frmPlnVroby.setEnabled(false);
			}
		});
		registerButton.setBounds(150, 80, 110, 25);
		panel.add(registerButton);
	}

	public static void zobrazTvorbaZamestnance() {
		Prihlaseni.casovac.restart();
		tz = new TvorbaZamestnanceOkno();
		tz.setVisible(true);
	}

	public static void zobrazZapisVyroby() {
		Prihlaseni.casovac.restart();
		HlavniOkno.vymazPodokna();
		HlavniOkno.vyroba = new VyrobaJPanel();
		HlavniOkno.vyroba.setBounds(0, 0, 950, 479);
		HlavniOkno.layeredPane.add(HlavniOkno.vyroba);
	}
	
	public static void zobrazKoeficienty() {
		Prihlaseni.casovac.restart();
		HlavniOkno.vymazPodokna();
		HlavniOkno.koeficient = new KoeficientJPanel();
		HlavniOkno.koeficient.setBounds(0, 0, 950, 479);
		HlavniOkno.layeredPane.add(HlavniOkno.koeficient);
	}

	public static void zobrazZmenaHesla() {
		Prihlaseni.casovac.restart();
		HlavniOkno.vymazPodokna();
		HlavniOkno.zmenitHeslo = new ZmenitHesloJPanel();
		HlavniOkno.zmenitHeslo.setBounds(0, 0, 950, 479);
		HlavniOkno.layeredPane.add(HlavniOkno.zmenitHeslo);
	}
	
	public static void zobrazUINovaDavka(){
		Prihlaseni.casovac.restart();
		Prihlaseni.nd = new NovaDavkaOkno();
		Prihlaseni.nd.setVisible(true);
	}
	
	public static void zobrazZamestnance(){
		Prihlaseni.casovac.restart();
		HlavniOkno.vymazPodokna();
		HlavniOkno.zamestnanci = new ZamestnanciJPanel();
		HlavniOkno.zamestnanci.setBounds(0, 0, 950, 479);
		HlavniOkno.layeredPane.add(HlavniOkno.zamestnanci);
	}

	public static Calendar getDnesniDatum() {
		return dnesniDatum;
	}
	
	public static void existujiStaraOznameni(){
		if(Vyroba.oznameni.size()>0){
			Calendar cd = (Calendar) Vyroba.oznameni.get(0).getDatumVytvoreni().clone();
			cd.add(Calendar.MONTH, 2);
			//staci jen kontrola prvni/nejstarsi polozky (novejsi polozky maji vetsi indexy) - jinak predelat na cyklus
			if(cd.getTimeInMillis()<Prihlaseni.dnesniDatum.getTimeInMillis()){
				for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
					Vyroba.zamestnanci.get(i).odstranStaraOznameni();
				}
			}
		}
	}

	public static void main(String[] args) {
		frmPlnVroby = new JFrame("Demo application");
		frmPlnVroby.setTitle("P\u0159ihl\u00E1\u0161en\u00ED");
		frmPlnVroby.setSize(300, 150);
		frmPlnVroby.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JPanel panel = new JPanel();
		frmPlnVroby.getContentPane().add(panel);
		zobrazPrihlasovaciOkno(panel);
		frmPlnVroby.setVisible(true);
		
		System.out.println("as z PC: " + Prihlaseni.dnesniDatum.getTime());
		aktualizujDatum();
		System.out.println("as pouit: " + Prihlaseni.dnesniDatum.getTime());
		spustTimer();
		
		existujiStaraOznameni();
		
		/**
		// melo by jet, ale po nekolika pokusech se sekne cely program
		new Thread(new Runnable() {
			public void run() {
				int delay = 5000;
				ActionListener taskPerformer = new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							aktualizujDatum();
						}
				};
				casovacData = new Timer(delay, taskPerformer);
				casovacData.start();
			}
		}).start();
		*/
		
		/**
		BasicPasswordEncryptor passwordEncryptor = new
		BasicPasswordEncryptor(); String encryptedPassword =
		passwordEncryptor.encryptPassword("admin"); 
		try (FileOutputStream out = new FileOutputStream("uzivatele.dat")) { 
			Properties properties = new Properties();
			properties.setProperty("admin", encryptedPassword);
			properties.store(out, "Loginy a hesla vsech uzivatelu systemu"); 
		}catch (IOException ee) { 
			ee.printStackTrace(); 
		}
		vyr = new Vyroba();
		try {
			Vyroba.addZamestnanci(0, "admin", "administrator", "admin", "");
		} catch (Exception e) {
			e.printStackTrace();
		}
		try{
			FileOutputStream fos = new FileOutputStream(cestaData);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			ObjectOutputStream oos = new ObjectOutputStream(bos);   
			oos.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
			oos.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
			oos.writeObject(new ArrayList<Material>(Vyroba.material));
			oos.close();
			bos.close();
			fos.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
		try{
			FileInputStream fis = new FileInputStream(cestaData);
			BufferedInputStream bis = new BufferedInputStream(fis);
			ObjectInputStream ois = new ObjectInputStream(bis);
			Vyroba.vyrobniStroje = (ArrayList<Stroj>) ois.readObject();
			Vyroba.zamestnanci = (ArrayList<Zamestnanec>) ois.readObject();
			Vyroba.material = (ArrayList<Material>) ois.readObject();
			ois.close();
			bis.close();
			fis.close();
			System.out.println(Vyroba.getZamestnanci().get(0).getJmeno());
		}catch(Exception ex){
			ex.printStackTrace();
		}
		*/
		
		
		
	}

}