package xslavic4.plan_vyroby;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JList;

import org.jasypt.util.password.BasicPasswordEncryptor;

import java.awt.Choice;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;

import java.awt.Font;

import javax.swing.ListSelectionModel;

public class PrirazeniZamestnancuOkno extends JDialog {

	private final JPanel contentPanel = new JPanel();

	protected static Stroj stroj;
	protected List<Zamestnanec> seznamVsechMoznych = new ArrayList<Zamestnanec>();
	protected List<Zamestnanec> seznamPrirazenych = new ArrayList<Zamestnanec>();
	protected List<Zamestnanec> seznamNeprirazenych = new ArrayList<Zamestnanec>();
	
	protected JScrollPane scrollPane_prirazeni;
	protected JScrollPane scrollPane_neprirazeni;
	protected JList prirazeni;
	protected JList neprirazeni;
	protected DefaultListModel neprirazeniModel;
	protected DefaultListModel prirazeniModel;

	public static void main(String[] args) {
		try {
			PrirazeniZamestnancuOkno dialog = new PrirazeniZamestnancuOkno();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public PrirazeniZamestnancuOkno() {
		setTitle("P\u0159i\u0159azen\u00ED d\u011Bln\u00EDk\u016F ke stroji");
		setBounds(100, 100, 700, 460);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		scrollPane_neprirazeni = new JScrollPane();
		scrollPane_neprirazeni.setBounds(10, 45, 278, 340);
		contentPanel.add(scrollPane_neprirazeni);
		
		neprirazeniModel = new DefaultListModel();
		prirazeniModel = new DefaultListModel();
		
		for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
			if(stroj.getDelnici().contains(Vyroba.zamestnanci.get(i))){
				prirazeniModel.addElement(Vyroba.zamestnanci.get(i).getJmeno()+" "+Vyroba.zamestnanci.get(i).getPrijmeni()+" ("+Vyroba.zamestnanci.get(i).getLogin()+")");
				seznamVsechMoznych.add(Vyroba.zamestnanci.get(i));
				seznamPrirazenych.add(Vyroba.zamestnanci.get(i));
			}else{
				if(Vyroba.zamestnanci.get(i).getRole().equals("delnik")){
					neprirazeniModel.addElement(Vyroba.zamestnanci.get(i).getJmeno()+" "+Vyroba.zamestnanci.get(i).getPrijmeni()+" ("+Vyroba.zamestnanci.get(i).getLogin()+")");
					seznamVsechMoznych.add(Vyroba.zamestnanci.get(i));
					seznamNeprirazenych.add(Vyroba.zamestnanci.get(i));
				}
			}
		}
		
		neprirazeni = new JList(neprirazeniModel);
		neprirazeni.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		scrollPane_neprirazeni.setViewportView(neprirazeni);
		
		JButton priradit = new JButton("P\u0159i\u0159adit >>");
		priradit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Prihlaseni.casovac.restart();
				try{
					seznamPrirazenych.add(seznamNeprirazenych.get(neprirazeni.getSelectedIndex()));
					seznamNeprirazenych.remove(neprirazeni.getSelectedIndex());
					prirazeniModel.addElement(neprirazeniModel.get(neprirazeni.getSelectedIndex()));
					neprirazeniModel.remove(neprirazeni.getSelectedIndex());
				}catch (ArrayIndexOutOfBoundsException ex){
				}
				neprirazeni.setSelectedIndex(-1);
			}
		});
		priradit.setBounds(290, 113, 105, 23);
		contentPanel.add(priradit);
		
		JButton vyradit = new JButton("<< Vy\u0159adit");
		vyradit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Prihlaseni.casovac.restart();
				try{
					seznamNeprirazenych.add(seznamPrirazenych.get(prirazeni.getSelectedIndex()));
					seznamPrirazenych.remove(prirazeni.getSelectedIndex());
					neprirazeniModel.addElement(prirazeniModel.get(prirazeni.getSelectedIndex()));
					prirazeniModel.remove(prirazeni.getSelectedIndex());
				}catch (ArrayIndexOutOfBoundsException ex){
				}
				prirazeni.setSelectedIndex(-1);
			}
		});
		vyradit.setBounds(290, 147, 105, 23);
		contentPanel.add(vyradit);
		
		JLabel lblNewLabel = new JLabel("Nep\u0159i\u0159azen\u00ED zam\u011Bstnanci:");
		lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 14));
		lblNewLabel.setBounds(10, 11, 175, 23);
		contentPanel.add(lblNewLabel);
		
		scrollPane_prirazeni = new JScrollPane();
		scrollPane_prirazeni.setBounds(396, 45, 278, 340);
		contentPanel.add(scrollPane_prirazeni);
		
		prirazeni = new JList(prirazeniModel);
		prirazeni.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		scrollPane_prirazeni.setViewportView(prirazeni);
		
		JLabel lblPiazenZamstnanci = new JLabel("P\u0159i\u0159azen\u00ED zam\u011Bstnanci:");
		lblPiazenZamstnanci.setFont(new Font("Tahoma", Font.PLAIN, 14));
		lblPiazenZamstnanci.setBounds(396, 11, 175, 23);
		contentPanel.add(lblPiazenZamstnanci);
		
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			
				JButton okButton = new JButton("Ulo\u017Eit");
				okButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						Prihlaseni.casovac.restart();
						try{
							RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
						    FileDescriptor fdData = fileData.getFD();
						    FileInputStream inData = new FileInputStream(fdData);
						    BufferedInputStream bisData = new BufferedInputStream(inData);
							ObjectInputStream oisData = new ObjectInputStream(bisData);
						    FileOutputStream outData = new FileOutputStream(fdData);
						    BufferedOutputStream bosData = new BufferedOutputStream(outData);
							ObjectOutputStream oosData = new ObjectOutputStream(bosData);
							//data nacteni aktualnich
							try{
								Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
								Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
								Vyroba.material = (ArrayList<Material>) oisData.readObject();
							}catch(Exception ex){
								ex.printStackTrace();
							}
							fileData.seek(0);
							//uzivatele
							boolean nalezeno = false;
							boolean zmeneniDelnici = false;
							List<Zamestnanec> kontaktovani = new ArrayList<Zamestnanec>();
							for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
								if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==stroj.getCisloStroje()){
									try{
									if(Vyroba.vyrobniStroje.get(i).getDelnici().size()!=stroj.getDelnici().size()){
										zmeneniDelnici = true;
									}
									if(!zmeneniDelnici){
										for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDelnici().size(); x++){
											if(!stroj.getDelnici().contains(Vyroba.vyrobniStroje.get(i).getDelnici().get(x))){
												zmeneniDelnici = true;
												break;
											}
										}
									}
									if(!zmeneniDelnici){
										//provedeni vsech zmen
										for(int x = 0; x < seznamNeprirazenych.size(); x++){
											if(Vyroba.vyrobniStroje.get(i).getDelnici().contains(seznamNeprirazenych.get(x))){
												//tzn. odebrali jsme ho
												//System.out.println("odstranen");
												for(int y = 0; y < Vyroba.zamestnanci.size(); y++){
													if(Vyroba.zamestnanci.get(y).equals(seznamNeprirazenych.get(x))){
														Oznameni oz = new Oznameni("Byl Vm odebrn pstup dlnka ke stroji. SAP oznaen: " + stroj.getSAPOznaceni() + ", firemn slo: " + stroj.getCisloStroje() + ", nzev: " + stroj.getVyrobce() + ": " + stroj.getNazevProduktu());
														Vyroba.oznameni.add(oz);
														Vyroba.zamestnanci.get(y).addOznameni(oz);
														kontaktovani.add(Vyroba.zamestnanci.get(y));
														break;
													}
												}
												for(int y = 0; y < Vyroba.vyrobniStroje.get(i).getDelnici().size(); y++){
													if(Vyroba.vyrobniStroje.get(i).getDelnici().get(y).getLogin().equals(seznamNeprirazenych.get(x).getLogin())&&Vyroba.vyrobniStroje.get(i).getDelnici().get(y).getCisloZamestnance()==seznamNeprirazenych.get(x).getCisloZamestnance()){
														Vyroba.vyrobniStroje.get(i).remDelnici(y);
														break;
													}
												}
												x--;
											}
										}
										for(int x = 0; x < seznamPrirazenych.size(); x++){
											if(!Vyroba.vyrobniStroje.get(i).getDelnici().contains(seznamPrirazenych.get(x))){
												//tzn. nasli jsme nekoho, kdo tam predtim prirazen nebyl = byl nami pridan
												//melo by byt nunte ho vyhladat v zamestnancich nove nactene Vyroby
												for(int y = 0; y < Vyroba.zamestnanci.size(); y++){
													if(Vyroba.zamestnanci.get(y).equals(seznamPrirazenych.get(x))){
														Vyroba.vyrobniStroje.get(i).addDelnici(Vyroba.zamestnanci.get(y));
														Oznameni oz = new Oznameni("Byl Vm vytvoen pstup dlnka ke stroji. SAP oznaen: " + stroj.getSAPOznaceni() + ", firemn slo: " + stroj.getCisloStroje() + ", nzev: " + stroj.getVyrobce() + ": " + stroj.getNazevProduktu());
														Vyroba.oznameni.add(oz);
														Vyroba.zamestnanci.get(y).addOznameni(oz);
														kontaktovani.add(Vyroba.zamestnanci.get(y));
														break;
													}
												}
											}
										}
										//pridani oznameni - jen tem, kterych se zmeny nedotkli
										for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDelnici().size(); x++){
											if(!kontaktovani.contains(Vyroba.vyrobniStroje.get(i).getDelnici().get(x))){
												Oznameni oz = new Oznameni("U stroje, u kterho jste veden jako mistr, byly zmnno piazen mistr. SAP oznaen: " + stroj.getSAPOznaceni() + ", firemn slo: " + stroj.getCisloStroje() + ", nzev: " + stroj.getVyrobce() + ": " + stroj.getNazevProduktu());
												Vyroba.oznameni.add(oz);
												Vyroba.vyrobniStroje.get(i).getDelnici().get(x).addOznameni(oz);
												kontaktovani.add(Vyroba.vyrobniStroje.get(i).getDelnici().get(x));
											}
										}
										for(int x = 0; x < Vyroba.zamestnanci.size(); x++){
											if((!kontaktovani.contains(Vyroba.zamestnanci.get(x)))&&Vyroba.zamestnanci.get(x).getRole().equals("administrator")){
												Oznameni oz = new Oznameni("U stroje jednoho ze stroj bylo zmnno piazen mistr. SAP oznaen: " + stroj.getSAPOznaceni() + ", firemn slo: " + stroj.getCisloStroje() + ", nzev: " + stroj.getVyrobce() + ": " + stroj.getNazevProduktu());
												Vyroba.oznameni.add(oz);
												Vyroba.zamestnanci.get(x).addOznameni(oz);
											}
										}
										//data ulozeni
										try{
											oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
											oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
											oosData.writeObject(new ArrayList<Material>(Vyroba.material));
										}catch(Exception ex){
											ex.printStackTrace();
											throw new Exception("Nepodarily se ulozit nove data");
										}
										Prihlaseni.pz.setVisible(false);
										//restart zalozky
										Prihlaseni.zobrazStroje();
										nalezeno = true;
										break;
									}
									}catch(Exception ex){
										System.err.println("chyba");
										ex.printStackTrace();
										nalezeno = true;
										zmeneniDelnici = false;
									}
								}
							}
							if(!nalezeno){
								Prihlaseni.pz.setVisible(false);
								Prihlaseni.zobrazStroje();
								Prihlaseni.zobrazChybu("Dan stroj byl v meziase zmnn jinm uivatelem!");
								throw new Exception("Dan stroj byl v meziase zmnn jinm uivatelem");
							}
							if(zmeneniDelnici&&nalezeno){
								Prihlaseni.pz.setVisible(false);
								Stroj.zobrazPrirazeniZamestnancu();
								Prihlaseni.zobrazChybu("Dan stroj byl v meziase zmnn jinm uivatelem!");
								throw new Exception("Dan stroj byl v meziase zmnn jinm uivatelem");
							}
							oosData.close();
							bosData.close();
							outData.close();
							oisData.close();
							bisData.close();
							inData.close();
							fileData.close();
						}catch(Exception ex){
							System.err.println("chyba u aktualizace dat");
							ex.printStackTrace();
						}
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);

				JButton cancelButton = new JButton("Zru\u0161it");
				cancelButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						Prihlaseni.casovac.restart();
						Prihlaseni.pz.setVisible(false);
						Prihlaseni.zobrazStroje();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
	}
}
