package xslavic4.plan_vyroby;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.RandomAccessFile;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

public class Stroj implements Serializable{
	
	private static final long serialVersionUID = -6674287677874261344L;
	private String SAPOznaceni;
	private int cisloStroje;
	private String nazevProduktu;
	private String vyrobce;
	private String popis;
	private String umisteni;
	private List<Zamestnanec> delnici = new ArrayList<Zamestnanec>();
	private List<Zamestnanec> mistri = new ArrayList<Zamestnanec>();
	private List<Davka> castiDavky = new ArrayList<Davka>();
	private int indexAktualniDavky = -1;
	private List<Calendar> volno = new ArrayList<Calendar>();
	private boolean aktivni;
	protected boolean[] smeny = new boolean[3];
	
	public Stroj(Zamestnanec mistr) {
		mistri.add(mistr);
	}

	public String getSAPOznaceni() {
		return SAPOznaceni;
	}

	public void setSAPOznaceni(String ozn) {
		boolean jedinecneOznaceni = true;
		for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
			if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(ozn)){
				jedinecneOznaceni = false;
				break;
			}
		}
		if(!jedinecneOznaceni){
			try {
				Prihlaseni.zobrazChybu("Oznaen stroje nen jedinen!");
				throw new Exception("Oznaceni stroje neni jedinecne!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			SAPOznaceni = ozn;
		}
	}

	public int getCisloStroje() {
		return this.cisloStroje;
	}

	public void setCisloStroje(int cisloStroje) {
		boolean jedinecneOznaceni = true;
		for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
			if(Vyroba.vyrobniStroje.get(i).getCisloStroje()==cisloStroje){
				jedinecneOznaceni = false;
				break;
			}
		}
		if(!jedinecneOznaceni){
			try {
				Prihlaseni.zobrazChybu("slo stroje nen jedinen!");
				throw new Exception("Cislo stroje neni jedinecne!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			this.cisloStroje = cisloStroje;
		}
	}

	public String getNazevProduktu() {
		return this.nazevProduktu;
	}

	public void setNazevProduktu(String nazevProduktu) {
		this.nazevProduktu = nazevProduktu;
	}

	public String getVyrobce() {
		return this.vyrobce;
	}

	public void setVyrobce(String vyrobce) {
		this.vyrobce = vyrobce;
	}

	public String getPopis() {
		return this.popis;
	}

	public void setPopis(String popis) {
		this.popis = popis;
	}

	public String getUmisteni() {
		return this.umisteni;
	}

	public void setUmisteni(String umisteni) {
		this.umisteni = umisteni;
	}

	public Zamestnanec getDelnici(int poradi) {
		return delnici.get(poradi);
	}
	
	public List<Zamestnanec> getDelnici() {
		return delnici;
	}

	public void addDelnici(Zamestnanec delnik) {
		delnici.add(delnik);
	}

	public void remDelnici(int idx) {
		delnici.remove(idx);
	}

	public Zamestnanec getMistri(int poradi) {
		return mistri.get(poradi);
	}
	
	public List<Zamestnanec> getMistri() {
		return mistri;
	}

	public void addMistri(Zamestnanec mistr) {
		mistri.add(mistr);
	}

	public void remMistri(int idx) throws Exception {
		if(mistri.size()>1){
			mistri.remove(idx);
		}else{
			Prihlaseni.zobrazChybu("Mistra nelze odstranit od stroje, protoe je jedinm mistrem tohoto stroje!");
			throw new Exception("Mistra nelze odstranit od stroje, protoze je jedinym mistrem tohoto stroje!");
		}
	}

	public List<Davka> getDavka() {
		return castiDavky;
	}

	public void addDavka(Davka davka) throws Exception {
		if(aktivni){
			castiDavky.add(davka);
		}else{
			Prihlaseni.zobrazChybu("Tento stroj nen v provozu!");
			throw new Exception("Tento stroj neni v provozu!");
		}
	}

	public void remDavka(int idx) {
		castiDavky.remove(idx);
	}

	public int getIndexAktualniDavky() {
		return this.indexAktualniDavky;
	}

	public void setIndexAktualniDavky(int indexAktualniDavky) {
		this.indexAktualniDavky = indexAktualniDavky;
	}

	public static void rozdelitDavku() {
		if(RozdeleniDavkyOkno.table.getSelectedRow()!=-1){
		if(RozdeleniDavkyOkno.table.getSelectedRow()!=RozdeleniDavkyOkno.smeny.length-1){
			try{
				//data
				RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
			    FileDescriptor fdData = fileData.getFD();
			    FileInputStream inData = new FileInputStream(fdData);
			    BufferedInputStream bisData = new BufferedInputStream(inData);
				ObjectInputStream oisData = new ObjectInputStream(bisData);
			    FileOutputStream outData = new FileOutputStream(fdData);
			    BufferedOutputStream bosData = new BufferedOutputStream(outData);
				ObjectOutputStream oosData = new ObjectOutputStream(bosData);
				//data nacteni aktualnich
				try{
					Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
					Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
					Vyroba.material = (ArrayList<Material>) oisData.readObject();
				}catch(Exception ex){
					ex.printStackTrace();
				}
				fileData.seek(0);
				boolean nalezeno = false;
				boolean nalezenStroj = false;
				boolean nalezenaDavka = false;
				for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
					if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(DavkyOkno.stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==DavkyOkno.stroj.getCisloStroje()){
						for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().size(); x++){
							if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni().equals(RozdeleniDavkyOkno.davka.getOznaceni())&&Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceniCasti().equals(RozdeleniDavkyOkno.davka.getOznaceniCasti())){
								boolean spravne = true;
								for(int q = 0; q < Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().size(); q++){
									if(!Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().get(q).equals(RozdeleniDavkyOkno.smeny[q])){
										spravne = false;
									}
								}
								if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().size()!=RozdeleniDavkyOkno.davka.getDataSmen().size()){
									spravne = false;
								}
								if(spravne){
									//provedeni vsech zmen
									Davka prvni = new Davka(Vyroba.vyrobniStroje.get(i).getDavka().get(x));
									Davka druha = new Davka(Vyroba.vyrobniStroje.get(i).getDavka().get(x));
									prvni.dataSmen = new ArrayList<Calendar>(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen);
									prvni.planSmen = new ArrayList<Integer>(Vyroba.vyrobniStroje.get(i).getDavka().get(x).planSmen);
									prvni.skutecnostSmen = new ArrayList<Integer>(Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen);
									prvni.smeny = Vyroba.vyrobniStroje.get(i).smeny.clone();
									druha.dataSmen = new ArrayList<Calendar>(Vyroba.vyrobniStroje.get(i).getDavka().get(x).dataSmen);
									druha.planSmen = new ArrayList<Integer>(Vyroba.vyrobniStroje.get(i).getDavka().get(x).planSmen);
									druha.skutecnostSmen = new ArrayList<Integer>(Vyroba.vyrobniStroje.get(i).getDavka().get(x).skutecnostSmen);
									druha.smeny = Vyroba.vyrobniStroje.get(i).smeny.clone();
									prvni.setOznaceniCasti(RozdeleniDavkyOkno.textField.getText());
									druha.setOznaceniCasti(RozdeleniDavkyOkno.textField_1.getText());
									for(int q = RozdeleniDavkyOkno.table.getSelectedRow()+1; q < Vyroba.vyrobniStroje.get(i).getDavka().get(x).getDataSmen().size(); q++){
										prvni.dataSmen.remove(prvni.dataSmen.size()-1);
										prvni.planSmen.remove(prvni.planSmen.size()-1);
										prvni.skutecnostSmen.remove(prvni.skutecnostSmen.size()-1);
									}
									int celkem = 0;
									for(int q = 0; q < prvni.getDataSmen().size(); q++){
										celkem = celkem + prvni.planSmen.get(q);
									}
									prvni.setCelkoveMnozstvi(celkem);
									prvni.setPlanovanyKonec(prvni.dataSmen.get(prvni.dataSmen.size()-1));
									for(int q = 0; q < RozdeleniDavkyOkno.table.getSelectedRow()+1; q++){
										druha.dataSmen.remove(0);
										druha.planSmen.remove(0);
										druha.skutecnostSmen.remove(0);
									}
									celkem = 0;
									for(int q = 0; q < druha.getDataSmen().size(); q++){
										celkem = celkem + druha.planSmen.get(q);
									}
									druha.setCelkoveMnozstvi(celkem);
									druha.setPlanovanyZacatek(druha.dataSmen.get(0));
									Vyroba.vyrobniStroje.get(i).getDavka().remove(x);
									Vyroba.vyrobniStroje.get(i).getDavka().add(x, druha);
									Vyroba.vyrobniStroje.get(i).getDavka().add(x, prvni);
									prvni.setPocetSmen(prvni.getDataSmen().size());
									druha.setPocetSmen(druha.getDataSmen().size());
									//oznameni
									Oznameni oz = new Oznameni("Dvka s oznaenm " + prvni.getOznaceni() + " byla rozdlena na vce st.");
									Vyroba.oznameni.add(oz);
									for(int q = 0; q < Vyroba.zamestnanci.size(); q++){
										if(Vyroba.vyrobniStroje.get(i).getMistri().contains(Vyroba.zamestnanci.get(q))){
											Vyroba.zamestnanci.get(q).addOznameni(oz);
										}
									}
									//data ulozeni
									try{
										oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
										oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
										oosData.writeObject(new ArrayList<Material>(Vyroba.material));
									}catch(Exception ex){
										ex.printStackTrace();
										throw new Exception("Nepodarilo se ulozit nove data");
									}
									nalezeno = true;
									//restart zalozky
									Prihlaseni.rd.setVisible(false);
									Prihlaseni.dav.setVisible(false);
									Stroj.zobrazDavky();
								}
								nalezenaDavka = true;
								break;
							}
						}
						nalezenStroj = true;
						break;
					}
				}
				if(!nalezenStroj){
					Prihlaseni.zobrazChybu("Stroj, u kterho mly bt provedeny zmny, byl v meziase zmnn.");
					throw new Exception("Stroj, u kterho mly bt provedeny zmny, byl v meziase zmnn.");
				}
				if(!nalezenaDavka&&nalezenStroj){
					Prihlaseni.zobrazChybu("Dvka, u kter mly bt provedenz zmny, byla v meziase zmnna.");
					throw new Exception("Dvka, u kter mly bt provedenz zmny, byla v meziase zmnna.");
				}
				if(!nalezeno&&nalezenStroj&&nalezenaDavka){
					Prihlaseni.zobrazChybu("Smny byly v meziase zmnny.");
					throw new Exception("Smny byly v meziase zmnny.");
				}
				oosData.close();
				bosData.close();
				outData.close();
				oisData.close();
				bisData.close();
				inData.close();
				fileData.close();
			}catch(Exception ex){
				System.err.println("chyba u aktualizace dat");
				ex.printStackTrace();
			}
		}else{
			Prihlaseni.zobrazChybu("Nelze zvolit posledn smnu hlavn dvky. Druh st dvky by byla przdn! ");
		}
		}else{
			Prihlaseni.zobrazChybu("Mus bt vybrna smna, podle kter se dvka rozdl.");
		}
	}

	public static void sloucitDavky() {
		if(!SlouceniDavkyOkno.list.isSelectionEmpty()||SlouceniDavkyOkno.list.getSelectedValues().length<2){
			int indicie[] = SlouceniDavkyOkno.list.getSelectedIndices();
			int prvni = indicie[0];
			boolean jsouPospolu = true;
			boolean stejnaDavka = true;
			for(int i = 1; i < indicie.length; i++){
				if(prvni+1==indicie[i]){
					prvni++;
				}else{
					jsouPospolu = false;
				}
			}
			String ozn = SlouceniDavkyOkno.davky[indicie[0]].getOznaceni();
			for(int i = 1; i < indicie.length; i++){
				if(!SlouceniDavkyOkno.davky[indicie[i]].getOznaceni().equals(ozn)){
					stejnaDavka = false;
				}
			}
			if(jsouPospolu&&stejnaDavka){
				//jsou u sebe
				try{
					//data
					RandomAccessFile fileData = new RandomAccessFile(Prihlaseni.cestaData, "rw");
				    FileDescriptor fdData = fileData.getFD();
				    FileInputStream inData = new FileInputStream(fdData);
				    BufferedInputStream bisData = new BufferedInputStream(inData);
					ObjectInputStream oisData = new ObjectInputStream(bisData);
				    FileOutputStream outData = new FileOutputStream(fdData);
				    BufferedOutputStream bosData = new BufferedOutputStream(outData);
					ObjectOutputStream oosData = new ObjectOutputStream(bosData);
					//data nacteni aktualnich
					try{
						Vyroba.vyrobniStroje =  (ArrayList<Stroj>) oisData.readObject();
						Vyroba.zamestnanci = (ArrayList<Zamestnanec>) oisData.readObject();
						Vyroba.material = (ArrayList<Material>) oisData.readObject();
					}catch(Exception ex){
						ex.printStackTrace();
					}
					fileData.seek(0);
					boolean nalezenStroj = false;
					boolean davkySpravne = true;
					for(int i = 0; i < Vyroba.vyrobniStroje.size(); i++){
						if(Vyroba.vyrobniStroje.get(i).getSAPOznaceni().equals(DavkyOkno.stroj.getSAPOznaceni())&&Vyroba.vyrobniStroje.get(i).getCisloStroje()==DavkyOkno.stroj.getCisloStroje()){
							for(int y = 0; y < Vyroba.vyrobniStroje.get(i).getDavka().size(); y++){
								if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).getOznaceni().equals(SlouceniDavkyOkno.davky[indicie[0]].getOznaceni())&&Vyroba.vyrobniStroje.get(i).getDavka().get(y).getOznaceniCasti().equals(SlouceniDavkyOkno.davky[indicie[0]].getOznaceniCasti())){
								//if(Vyroba.vyrobniStroje.get(i).getDavka().get(y).getOznaceni().equals(SlouceniDavkyOkno.davky[indicie[0]].getOznaceni())&&Vyroba.vyrobniStroje.get(i).getDavka().get(y).getOznaceniCasti().equals(SlouceniDavkyOkno.davky[indicie[0]].getOznaceniCasti())&&Vyroba.vyrobniStroje.get(i).getDavka().get(y).getPlanovanyZacatek().equals(SlouceniDavkyOkno.davky[indicie[0]].getPlanovanyZacatek())){
									davkySpravne = true;
									for(int q = 1; q < indicie.length; q++){
										System.out.println(SlouceniDavkyOkno.davky[indicie[q]].getOznaceniCasti());
										System.out.println(Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).getOznaceniCasti());
										System.out.println();
										if(!(Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).getOznaceni().equals(SlouceniDavkyOkno.davky[indicie[q]].getOznaceni())&&Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).getOznaceniCasti().equals(SlouceniDavkyOkno.davky[indicie[q]].getOznaceniCasti()))){
											davkySpravne = false;
										}
									}
									System.out.println(davkySpravne);
									if(davkySpravne){
										//slouceni do jedne davky
										for(int q = 1; q < indicie.length; q++){
											for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).getDataSmen().size(); x++){
												Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.add(Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).dataSmen.get(x));
												Vyroba.vyrobniStroje.get(i).getDavka().get(y).planSmen.add(Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).planSmen.get(x));
												Vyroba.vyrobniStroje.get(i).getDavka().get(y).skutecnostSmen.add(Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).skutecnostSmen.get(x));
												if(q==indicie.length-1&&x==Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).getDataSmen().size()-1){
													Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPlanovanyKonec(Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.get(Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.size()-1));
												}
												if(x==0){
													Vyroba.vyrobniStroje.get(i).getDavka().get(y).setCelkoveMnozstvi(Vyroba.vyrobniStroje.get(i).getDavka().get(y).getCelkoveMnozstvi()+Vyroba.vyrobniStroje.get(i).getDavka().get(y+q).getCelkoveMnozstvi());
												}
											}
										}
										Vyroba.vyrobniStroje.get(i).getDavka().get(y).setPocetSmen(Vyroba.vyrobniStroje.get(i).getDavka().get(y).dataSmen.size());
										//oznameni
										Oznameni oz = new Oznameni("sti dvky s oznaenm " + Vyroba.vyrobniStroje.get(i).getDavka().get(y).getOznaceni() + " byly sloueny.");
										Vyroba.oznameni.add(oz);
										for(int q = 0; q < Vyroba.zamestnanci.size(); q++){
											if(Vyroba.vyrobniStroje.get(i).getMistri().contains(Vyroba.zamestnanci.get(q))){
												Vyroba.zamestnanci.get(q).addOznameni(oz);
											}
										}
										//smazani davek
										for(int q = 1; q < indicie.length; q++){
											Vyroba.vyrobniStroje.get(i).remDavka(y+1);
										}
										//Oznaceni casti - jen pokud davka jeste je rozdelena na vice casti (jinak se nezapise)
										int pocet = -1;
										String oznaceni = Vyroba.vyrobniStroje.get(i).getDavka().get(y).getOznaceni();
										for(int x = 0; x < Vyroba.vyrobniStroje.get(i).getDavka().size(); x++){
											if(Vyroba.vyrobniStroje.get(i).getDavka().get(x).getOznaceni().equals(oznaceni)){
												pocet++;
											}
										}
										if(pocet>0){
											Vyroba.vyrobniStroje.get(i).getDavka().get(y).setOznaceniCasti(SlouceniDavkyOkno.textField.getText());
										}
										//ulozeni
										try{
											oosData.writeObject(new ArrayList<Stroj>(Vyroba.vyrobniStroje));
											oosData.writeObject(new ArrayList<Zamestnanec>(Vyroba.zamestnanci));
											oosData.writeObject(new ArrayList<Material>(Vyroba.material));
										}catch(Exception ex){
											ex.printStackTrace();
											throw new Exception("Nepodarilo se ulozit nove data");
										}
										Prihlaseni.sd.setVisible(false);
										Prihlaseni.dav.setVisible(false);
										Stroj.zobrazDavky();
									}
									if(davkySpravne){
										break;
									}
								}
							}
							nalezenStroj = true;
							break;
						}
					}
					if(!nalezenStroj){
						Prihlaseni.zobrazChybu("Stroj, u kterho mly bt provedeny zmny, byl v meziase zmnn.");
						throw new Exception("Stroj, u kterho mly bt provedeny zmny, byl v meziase zmnn.");
					}
					if(nalezenStroj&&!davkySpravne){
						Prihlaseni.zobrazChybu("Dvky byly v meziase zmnny jinm uivatelem.");
						throw new Exception("Dvky byly v meziase zmnny jinm uivatelem.");
					}
					oosData.close();
					bosData.close();
					outData.close();
					oisData.close();
					bisData.close();
					inData.close();
					fileData.close();
				}catch(Exception ex){
					System.err.println("chyba u aktualizace dat");
					ex.printStackTrace();
				}
			}else{
				if(!stejnaDavka){
					Prihlaseni.zobrazChybu("Vybran dvky jsou z rznch hlavnch dvek, proto je nelze slouit dohromady.");
				}else{
					//nejsou u sebe
					Prihlaseni.sd.setVisible(false);
					Prihlaseni.dav.setVisible(false);
					Stroj.zobrazDavky();
					Prihlaseni.zobrazChybu("Dvky nejsou u sebe! Ped slouenm je peskldejte tak, aby na sebe navazovaly.");
				}
			}
		}else{
			Prihlaseni.zobrazChybu("Vyberte alespo 2 dvky ke slouen. ");
		}
	}

	public void posunoutDavkuDopredu(int idx) {
		if(idx>0){
			castiDavky.add(idx-1, castiDavky.get(idx));
			castiDavky.remove(idx+1);
		}
	}

	public void posunoutDavkuDozadu(int idx) {
		if(idx<castiDavky.size()-1){
			castiDavky.add(idx+1, castiDavky.get(idx));
			castiDavky.remove(idx);
		}
	}
	
	public Calendar getVolno(int idx) {
		return volno.get(idx);
	}
	
	public List<Calendar> getVolno() {
		return volno;
	}

	public void addVolno(Calendar volno) {
		this.volno.add(volno);
	}

	public void remVolno(int idx) {
		volno.remove(idx);
	}

	//zpozdeni ve dnech oproti planovanemu startu = data, na ktere vychazelo v dobe vzniku (minus = jsme napred, kladna hodnota = zpozdeni)
	public double zpozdeniDavky(int idx) {
		return (-castiDavky.get(idx).getPuvodniZacatek().getTimeInMillis()+castiDavky.get(idx).getPlanovanyZacatek().getTimeInMillis())/86000000;
	}
	//? ve smenach - rozsireni do budoucna - misto prace s davkami a "napasovanim" do kalendare by se muselo pracovat s kalendarnimi dny (kazdy den by mel cislo davky)

	//plneni daneho dne
	public Double plneni(Calendar datum) {
		for(int i = 0; i < castiDavky.size();i++){
			if(castiDavky.get(i).getPlanovanyZacatek().getTimeInMillis()<datum.getTimeInMillis()&&datum.getTimeInMillis()<castiDavky.get(i).getPlanovanyKonec().getTimeInMillis()){
				for(int x = 0; x < castiDavky.get(i).getDataSmen().size(); x++){
					if(castiDavky.get(i).getDataSmen().get(x).getTimeInMillis()==datum.getTimeInMillis()){
						try{
							return castiDavky.get(i).getSkutecnostSmen().get(x).doubleValue() / castiDavky.get(i).getPlanSmen().get(x).doubleValue();
						}catch(Exception ex){
							return 0.0;
						}
					}
				}
				break;
			}
		}
		return 0.0;
		//nebo vyhodit chybu o nenalezeni datu
	}

	//plneni dane davky od jejiho zacatku po dany den
	public double uspesnostPlneni(Calendar datum) {
		for(int i = 0; i < castiDavky.size();i++){
			if(castiDavky.get(i).getPlanovanyZacatek().getTimeInMillis()<datum.getTimeInMillis()&&datum.getTimeInMillis()<castiDavky.get(i).getPlanovanyKonec().getTimeInMillis()){
				double sumaPlanu = 0.0;
				double sumaSkutecnosti = 0.0;
				for(int x = 0; x < castiDavky.get(i).getDataSmen().size(); x++){
					try{
						sumaPlanu += castiDavky.get(i).getPlanSmen().get(x);
					}catch(Exception ex){
					}
					try{
						sumaSkutecnosti += castiDavky.get(i).getSkutecnostSmen().get(x);
					}catch(Exception ex){
					}
					if(castiDavky.get(i).getDataSmen().get(x).getTimeInMillis()==datum.getTimeInMillis()){
						try{
							return sumaSkutecnosti / sumaPlanu;
						}catch(Exception ex){
							return 0.0;
						}
					}
				}
				break;
			}
		}
		return 0.0;
		//nebo vyhodit chybu o nenalezeni datu
	}

	public boolean getAktivni() {
		return this.aktivni;
	}

	public void setAktivni(boolean aktivni) {
		this.aktivni = aktivni;
	}

	public boolean[] getSmeny() {
		return this.smeny;
	}

	public void setSmeny(boolean[] smeny) {
		this.smeny = smeny;
	}

	public static void zobrazDavky() {
		Prihlaseni.dav = new DavkyOkno();
		Prihlaseni.dav.setVisible(true);
	}

	public static void zobrazRozdeleniDavky() {
		Prihlaseni.rd = new RozdeleniDavkyOkno();
		Prihlaseni.rd.setVisible(true);
	}
	
	public static void zobrazSlouceniDavky() {
		Prihlaseni.sd = new SlouceniDavkyOkno();
		Prihlaseni.sd.setVisible(true);
	}

	public static void zmenPoradiDavek(Davka[] davky) {
		System.out.println("---");
		for(int i = 0; i < PoradiOkno.pozice.size(); i++){
			Vyroba.vyrobniStroje.get(PoradiOkno.idxStroje).getDavka().set(PoradiOkno.nejnizsiIndex+i, davky[PoradiOkno.pozice.get(i)]);
		}
	}

	public static void zobrazPoradiDavek() {
		Prihlaseni.pd = new PoradiOkno();
		Prihlaseni.pd.setVisible(true);
	}

	public static void zobrazPrirazeniZamestnancu() {
		Prihlaseni.pz = new PrirazeniZamestnancuOkno();
		Prihlaseni.pz.setVisible(true);
	}
	
	public static void zobrazPrirazeniMistru() {
		Prihlaseni.pm = new PrirazeniMistruOkno();
		Prihlaseni.pm.setVisible(true);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((SAPOznaceni == null) ? 0 : SAPOznaceni.hashCode());
		result = prime * result + (aktivni ? 1231 : 1237);
		result = prime * result + cisloStroje;
		result = prime * result
				+ ((nazevProduktu == null) ? 0 : nazevProduktu.hashCode());
		result = prime * result + ((popis == null) ? 0 : popis.hashCode());
		result = prime * result + Arrays.hashCode(smeny);
		result = prime * result
				+ ((umisteni == null) ? 0 : umisteni.hashCode());
		result = prime * result + ((vyrobce == null) ? 0 : vyrobce.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Stroj other = (Stroj) obj;
		if (SAPOznaceni == null) {
			if (other.SAPOznaceni != null)
				return false;
		} else if (!SAPOznaceni.equals(other.SAPOznaceni))
			return false;
		if (aktivni != other.aktivni)
			return false;
		if (cisloStroje != other.cisloStroje)
			return false;
		if (nazevProduktu == null) {
			if (other.nazevProduktu != null)
				return false;
		} else if (!nazevProduktu.equals(other.nazevProduktu))
			return false;
		if (popis == null) {
			if (other.popis != null)
				return false;
		} else if (!popis.equals(other.popis))
			return false;
		if (!Arrays.equals(smeny, other.smeny))
			return false;
		if (umisteni == null) {
			if (other.umisteni != null)
				return false;
		} else if (!umisteni.equals(other.umisteni))
			return false;
		if (vyrobce == null) {
			if (other.vyrobce != null)
				return false;
		} else if (!vyrobce.equals(other.vyrobce))
			return false;
		return true;
	}
	
}