package xslavic4.plan_vyroby;

import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.io.Reader;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Properties;

import org.apache.commons.lang3.RandomStringUtils;
import org.jasypt.util.password.*;

public class Zamestnanec implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -5931045332995437231L;
	private int cisloZamestnance;
	private List<Oznameni> systemovaOznameni = new ArrayList<Oznameni>();
	private String login;
	private String role;
	private String jmeno;
	private String prijmeni;

	public Zamestnanec() {
	}
	
	public Zamestnanec(Zamestnanec zam) {
		cisloZamestnance = zam.cisloZamestnance;
		login = zam.login;
		role = zam.role;
		jmeno = zam.jmeno;
		prijmeni = zam.prijmeni;
	}
	
	public Zamestnanec(int cz, String log, String rol,String jm, String pr) throws Exception {
		if(log.length()<5){
			Prihlaseni.zobrazChybu("Login mus bt alespo dlky 5!");
			throw new Exception("Login musi byt alespon delky 5!");
		}else{
			boolean jedinecneCZ = true;
			boolean jedinecnyLogin = true;
			for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
				if(Vyroba.zamestnanci.get(i).getCisloZamestnance()==cz){
					jedinecneCZ = false;
					break;
				}
				if(Vyroba.zamestnanci.get(i).getLogin().equals(log)){
					jedinecnyLogin = false;
					break;
				}
			}
			if(!jedinecneCZ){
				try {
					Prihlaseni.zobrazChybu("slo zamstnance nen jedinen!");
					throw new Exception("Cislo zamestnance neni jedinecne!");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}else{
				if(!jedinecnyLogin){
					try {
						Prihlaseni.zobrazChybu("Login zamstnance nen jedinen!");
						throw new Exception("Login zamestnance neni jedinecny!");
					} catch (Exception e) {
						e.printStackTrace();
					}
				}else{
					cisloZamestnance = cz;
					login = log;
					role = rol;
					jmeno = jm;
					prijmeni = pr;
				}
			}
		}
	}

	public void addOznameni(Oznameni oznameni) {
		systemovaOznameni.add(oznameni);
	}

	public void odstranStaraOznameni() {
		for(int i = 0; i < systemovaOznameni.size(); i++){
			Calendar cd = (Calendar) systemovaOznameni.get(i).getDatumVytvoreni().clone();
			cd.add(Calendar.MONTH, 2);
			if(cd.getTimeInMillis()<Prihlaseni.getDnesniDatum().getTimeInMillis()){
				systemovaOznameni.remove(i);
				i--;
			}else{
				//nasli jsme prvni mladsi zaznam jak 2 mesice - vetsi indexy jsou s jistotou jeste mladsi
				break;
			}
		}
	}

	public List<Oznameni> getSystemovaOznameni() {
		return systemovaOznameni;
	}

	public int getCisloZamestnance() {
		return this.cisloZamestnance;
	}

	public String getLogin() {
		return this.login;
	}

	public void setLogin(String log) {
		if(log.length()<5){
			try {
				Prihlaseni.zobrazChybu("Login mus byt alespo dlky 5!");
				throw new Exception("Login musi byt alespon delky 5!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			boolean jedinecnyLogin = true;
			for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
				if(Vyroba.zamestnanci.get(i).getLogin().equals(log)){
					jedinecnyLogin = false;
					break;
				}
			}
			if(!jedinecnyLogin){
				try {
					Prihlaseni.zobrazChybu("Login zamstnance nen jedinen!!");
					throw new Exception("Login zamestnance neni jedinecny!");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}else{
				this.login = log;
			}
		}
	}

	public static boolean povoleneHeslo(String heslo) throws Exception {
		if(heslo.length()<5){
			Prihlaseni.zobrazChybu("Heslo mus bt alespo dlky 5!");
			throw new Exception("Heslo musi byt alespon delky 5!");
		}else{
			return true;
		}
	}

	public String getRole() {
		return this.role;
	}

	public void setRole(String role) {
		if(cisloZamestnance==0){
			try {
				Prihlaseni.zobrazChybu("Zamstnanci s tmto ID nelze zmnit role!");
				throw new Exception("Zamestnanci s timto ID nelze zmenit role!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			this.role = role;
		}
	}

	public static String generovatHeslo() {
		return RandomStringUtils.randomAlphanumeric(6);
	}

	public String getJmeno() {
		return this.jmeno;
	}

	public void setJmeno(String jmeno) {
		this.jmeno = jmeno;
	}

	public String getPrijmeni() {
		return this.prijmeni;
	}

	public void setPrijmeni(String prijmeni) {
		this.prijmeni = prijmeni;
	}

	public static void zobrazZmenitZamestnance() {
		Prihlaseni.zmenz = new ZmenitZamestnanceOkno();
		Prihlaseni.zmenz.setVisible(true);
	}

	public void zrusitPrihlasovaciUdaje() {
		Properties props = new Properties();
		try {
			RandomAccessFile file = new RandomAccessFile(Prihlaseni.cestaUzivatele, "rw");
			FileDescriptor fd = file.getFD();
		    FileInputStream in = new FileInputStream(fd);
		    FileOutputStream out = new FileOutputStream(fd);
			props.load(in);
			file.getChannel().truncate(0);
			props.remove(login);
			props.store(out, "Loginy a hesla vsech uzivatelu systemu");
			in.close();
			out.close();
			file.close();
			//Prihlaseni.zobrazPotvrzeni("Heslo bylo spn zmnno.");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void zmenHeslo(String st) {
		BasicPasswordEncryptor passwordEncryptor = new BasicPasswordEncryptor(); 
		String encryptedPassword = passwordEncryptor.encryptPassword(st);
		Properties props = new Properties();
		try {
			RandomAccessFile file = new RandomAccessFile(Prihlaseni.cestaUzivatele, "rw");
			FileDescriptor fd = file.getFD();
		    FileInputStream in = new FileInputStream(fd);
		    FileOutputStream out = new FileOutputStream(fd);
			props.load(in);
			file.getChannel().truncate(0);
			props.remove(Prihlaseni.loginUzivatele);
			props.setProperty(Prihlaseni.loginUzivatele, encryptedPassword);
			props.store(out, "Loginy a hesla vsech uzivatelu systemu");
			in.close();
			out.close();
			file.close();
			//Prihlaseni.zobrazPotvrzeni("Heslo bylo spn zmnno.");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void zmenHeslo(String st, String login, String staryLogin) throws Exception {
		Properties props = new Properties();
		try {
			RandomAccessFile file = new RandomAccessFile(Prihlaseni.cestaUzivatele, "rw");
			FileDescriptor fd = file.getFD();
		    FileInputStream in = new FileInputStream(fd);
		    FileOutputStream out = new FileOutputStream(fd);
			props.load(in);
			file.getChannel().truncate(0);
			props.remove(staryLogin);
			props.setProperty(login, st);
			props.store(out, "Loginy a hesla vsech uzivatelu systemu");
			in.close();
			out.close();
			file.close();
		} catch (Exception e) {
			e.printStackTrace();
			throw new Exception("Heslo nebylo mozne zmenit v souboru");
		}
	}
	
	public void zmenitUdaje(int cz, String log, String rol, String jm, String pr) throws Exception{
		try{
			setLogin(log);
			boolean jedinecneCZ = true;
			for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
				if(Vyroba.zamestnanci.get(i).getCisloZamestnance()==cz){
					jedinecneCZ = false;
					break;
				}
			}
			if(!jedinecneCZ){
				try {
					Prihlaseni.zobrazChybu("slo zamstnance nen jedinen!");
					throw new Exception("Cislo zamestnance neni jedinecne!");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			cisloZamestnance = cz;
			role = rol;
			jmeno = jm;
			prijmeni = pr;
		}catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	public void zmenitUdaje(String log, String rol, String jm, String pr) throws Exception{
		try{
			setLogin(log);
			role = rol;
			jmeno = jm;
			prijmeni = pr;
		}catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	public void zmenitUdaje(int cz, String rol, String jm, String pr) throws Exception{
		try{
			boolean jedinecneCZ = true;
			for(int i = 0; i < Vyroba.zamestnanci.size(); i++){
				if(Vyroba.zamestnanci.get(i).getCisloZamestnance()==cz){
					jedinecneCZ = false;
					break;
				}
			}
			if(!jedinecneCZ){
				try {
					Prihlaseni.zobrazChybu("slo zamstnance nen jedinen!");
					throw new Exception("Cislo zamestnance neni jedinecne!");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			cisloZamestnance = cz;
			role = rol;
			jmeno = jm;
			prijmeni = pr;
		}catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	public void zmenitUdaje(String rol, String jm, String pr) throws Exception{
		try{
			role = rol;
			jmeno = jm;
			prijmeni = pr;
		}catch (Exception ex){
			ex.printStackTrace();
		}
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + cisloZamestnance;
		result = prime * result + ((jmeno == null) ? 0 : jmeno.hashCode());
		result = prime * result + ((login == null) ? 0 : login.hashCode());
		result = prime * result
				+ ((prijmeni == null) ? 0 : prijmeni.hashCode());
		result = prime * result + ((role == null) ? 0 : role.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Zamestnanec other = (Zamestnanec) obj;
		if (cisloZamestnance != other.cisloZamestnance)
			return false;
		if (jmeno == null) {
			if (other.jmeno != null)
				return false;
		} else if (!jmeno.equals(other.jmeno))
			return false;
		if (login == null) {
			if (other.login != null)
				return false;
		} else if (!login.equals(other.login))
			return false;
		if (prijmeni == null) {
			if (other.prijmeni != null)
				return false;
		} else if (!prijmeni.equals(other.prijmeni))
			return false;
		if (role == null) {
			if (other.role != null)
				return false;
		} else if (!role.equals(other.role))
			return false;
		return true;
	}
	
	
	
}